# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetInterRegionBandwidthsResult',
    'AwaitableGetInterRegionBandwidthsResult',
    'get_inter_region_bandwidths',
    'get_inter_region_bandwidths_output',
]

@pulumi.output_type
class GetInterRegionBandwidthsResult:
    """
    A collection of values returned by getInterRegionBandwidths.
    """
    def __init__(__self__, cen_id=None, id=None, ids=None, inter_region_bandwidths=None, output_file=None, total_count=None):
        if cen_id and not isinstance(cen_id, str):
            raise TypeError("Expected argument 'cen_id' to be a str")
        pulumi.set(__self__, "cen_id", cen_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if ids and not isinstance(ids, list):
            raise TypeError("Expected argument 'ids' to be a list")
        pulumi.set(__self__, "ids", ids)
        if inter_region_bandwidths and not isinstance(inter_region_bandwidths, list):
            raise TypeError("Expected argument 'inter_region_bandwidths' to be a list")
        pulumi.set(__self__, "inter_region_bandwidths", inter_region_bandwidths)
        if output_file and not isinstance(output_file, str):
            raise TypeError("Expected argument 'output_file' to be a str")
        pulumi.set(__self__, "output_file", output_file)
        if total_count and not isinstance(total_count, int):
            raise TypeError("Expected argument 'total_count' to be a int")
        pulumi.set(__self__, "total_count", total_count)

    @property
    @pulumi.getter(name="cenId")
    def cen_id(self) -> Optional[str]:
        """
        The cen ID of the cen inter region bandwidth.
        """
        return pulumi.get(self, "cen_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def ids(self) -> Optional[Sequence[str]]:
        return pulumi.get(self, "ids")

    @property
    @pulumi.getter(name="interRegionBandwidths")
    def inter_region_bandwidths(self) -> Sequence['outputs.GetInterRegionBandwidthsInterRegionBandwidthResult']:
        """
        The collection of cen inter region bandwidth query.
        """
        return pulumi.get(self, "inter_region_bandwidths")

    @property
    @pulumi.getter(name="outputFile")
    def output_file(self) -> Optional[str]:
        return pulumi.get(self, "output_file")

    @property
    @pulumi.getter(name="totalCount")
    def total_count(self) -> int:
        """
        The total count of cen inter region bandwidth query.
        """
        return pulumi.get(self, "total_count")


class AwaitableGetInterRegionBandwidthsResult(GetInterRegionBandwidthsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetInterRegionBandwidthsResult(
            cen_id=self.cen_id,
            id=self.id,
            ids=self.ids,
            inter_region_bandwidths=self.inter_region_bandwidths,
            output_file=self.output_file,
            total_count=self.total_count)


def get_inter_region_bandwidths(cen_id: Optional[str] = None,
                                ids: Optional[Sequence[str]] = None,
                                output_file: Optional[str] = None,
                                opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetInterRegionBandwidthsResult:
    """
    Use this data source to query detailed information of cen inter region bandwidths
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo_cen = volcengine.cen.Cen("fooCen",
        cen_name="acc-test-cen",
        description="acc-test",
        project_name="default",
        tags=[volcengine.cen.CenTagArgs(
            key="k1",
            value="v1",
        )])
    foo_bandwidth_package = volcengine.cen.BandwidthPackage("fooBandwidthPackage",
        local_geographic_region_set_id="China",
        peer_geographic_region_set_id="China",
        bandwidth=5,
        cen_bandwidth_package_name="acc-test-cen-bp",
        description="acc-test",
        billing_type="PrePaid",
        period_unit="Month",
        period=1,
        project_name="default",
        tags=[volcengine.cen.BandwidthPackageTagArgs(
            key="k1",
            value="v1",
        )])
    foo_bandwidth_package_associate = volcengine.cen.BandwidthPackageAssociate("fooBandwidthPackageAssociate",
        cen_bandwidth_package_id=foo_bandwidth_package.id,
        cen_id=foo_cen.id)
    foo_inter_region_bandwidth = volcengine.cen.InterRegionBandwidth("fooInterRegionBandwidth",
        cen_id=foo_cen.id,
        local_region_id="cn-beijing",
        peer_region_id="cn-shanghai",
        bandwidth=2,
        opts=pulumi.ResourceOptions(depends_on=[foo_bandwidth_package_associate]))
    foo_inter_region_bandwidths = volcengine.cen.get_inter_region_bandwidths_output(ids=[foo_inter_region_bandwidth.id])
    ```


    :param str cen_id: The ID of the cen.
    :param Sequence[str] ids: A list of cen inter region bandwidth IDs.
    :param str output_file: File name where to save data source results.
    """
    __args__ = dict()
    __args__['cenId'] = cen_id
    __args__['ids'] = ids
    __args__['outputFile'] = output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('volcengine:cen/getInterRegionBandwidths:getInterRegionBandwidths', __args__, opts=opts, typ=GetInterRegionBandwidthsResult).value

    return AwaitableGetInterRegionBandwidthsResult(
        cen_id=pulumi.get(__ret__, 'cen_id'),
        id=pulumi.get(__ret__, 'id'),
        ids=pulumi.get(__ret__, 'ids'),
        inter_region_bandwidths=pulumi.get(__ret__, 'inter_region_bandwidths'),
        output_file=pulumi.get(__ret__, 'output_file'),
        total_count=pulumi.get(__ret__, 'total_count'))


@_utilities.lift_output_func(get_inter_region_bandwidths)
def get_inter_region_bandwidths_output(cen_id: Optional[pulumi.Input[Optional[str]]] = None,
                                       ids: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                                       output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                       opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetInterRegionBandwidthsResult]:
    """
    Use this data source to query detailed information of cen inter region bandwidths
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo_cen = volcengine.cen.Cen("fooCen",
        cen_name="acc-test-cen",
        description="acc-test",
        project_name="default",
        tags=[volcengine.cen.CenTagArgs(
            key="k1",
            value="v1",
        )])
    foo_bandwidth_package = volcengine.cen.BandwidthPackage("fooBandwidthPackage",
        local_geographic_region_set_id="China",
        peer_geographic_region_set_id="China",
        bandwidth=5,
        cen_bandwidth_package_name="acc-test-cen-bp",
        description="acc-test",
        billing_type="PrePaid",
        period_unit="Month",
        period=1,
        project_name="default",
        tags=[volcengine.cen.BandwidthPackageTagArgs(
            key="k1",
            value="v1",
        )])
    foo_bandwidth_package_associate = volcengine.cen.BandwidthPackageAssociate("fooBandwidthPackageAssociate",
        cen_bandwidth_package_id=foo_bandwidth_package.id,
        cen_id=foo_cen.id)
    foo_inter_region_bandwidth = volcengine.cen.InterRegionBandwidth("fooInterRegionBandwidth",
        cen_id=foo_cen.id,
        local_region_id="cn-beijing",
        peer_region_id="cn-shanghai",
        bandwidth=2,
        opts=pulumi.ResourceOptions(depends_on=[foo_bandwidth_package_associate]))
    foo_inter_region_bandwidths = volcengine.cen.get_inter_region_bandwidths_output(ids=[foo_inter_region_bandwidth.id])
    ```


    :param str cen_id: The ID of the cen.
    :param Sequence[str] ids: A list of cen inter region bandwidth IDs.
    :param str output_file: File name where to save data source results.
    """
    ...
