# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['CfwControlPolicyPriorityArgs', 'CfwControlPolicyPriority']

@pulumi.input_type
class CfwControlPolicyPriorityArgs:
    def __init__(__self__, *,
                 direction: pulumi.Input[str],
                 rule_id: pulumi.Input[str],
                 new_prio: Optional[pulumi.Input[int]] = None):
        """
        The set of arguments for constructing a CfwControlPolicyPriority resource.
        :param pulumi.Input[str] direction: The direction of the control policy. Valid values: `in`, `out`.
        :param pulumi.Input[str] rule_id: The rule id of the control policy.
        :param pulumi.Input[int] new_prio: The new priority of the control policy. The priority increases in order from 1, with lower priority indicating higher priority.
        """
        pulumi.set(__self__, "direction", direction)
        pulumi.set(__self__, "rule_id", rule_id)
        if new_prio is not None:
            pulumi.set(__self__, "new_prio", new_prio)

    @property
    @pulumi.getter
    def direction(self) -> pulumi.Input[str]:
        """
        The direction of the control policy. Valid values: `in`, `out`.
        """
        return pulumi.get(self, "direction")

    @direction.setter
    def direction(self, value: pulumi.Input[str]):
        pulumi.set(self, "direction", value)

    @property
    @pulumi.getter(name="ruleId")
    def rule_id(self) -> pulumi.Input[str]:
        """
        The rule id of the control policy.
        """
        return pulumi.get(self, "rule_id")

    @rule_id.setter
    def rule_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "rule_id", value)

    @property
    @pulumi.getter(name="newPrio")
    def new_prio(self) -> Optional[pulumi.Input[int]]:
        """
        The new priority of the control policy. The priority increases in order from 1, with lower priority indicating higher priority.
        """
        return pulumi.get(self, "new_prio")

    @new_prio.setter
    def new_prio(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "new_prio", value)


@pulumi.input_type
class _CfwControlPolicyPriorityState:
    def __init__(__self__, *,
                 direction: Optional[pulumi.Input[str]] = None,
                 new_prio: Optional[pulumi.Input[int]] = None,
                 prio: Optional[pulumi.Input[int]] = None,
                 rule_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering CfwControlPolicyPriority resources.
        :param pulumi.Input[str] direction: The direction of the control policy. Valid values: `in`, `out`.
        :param pulumi.Input[int] new_prio: The new priority of the control policy. The priority increases in order from 1, with lower priority indicating higher priority.
        :param pulumi.Input[int] prio: The priority of the control policy.
        :param pulumi.Input[str] rule_id: The rule id of the control policy.
        """
        if direction is not None:
            pulumi.set(__self__, "direction", direction)
        if new_prio is not None:
            pulumi.set(__self__, "new_prio", new_prio)
        if prio is not None:
            pulumi.set(__self__, "prio", prio)
        if rule_id is not None:
            pulumi.set(__self__, "rule_id", rule_id)

    @property
    @pulumi.getter
    def direction(self) -> Optional[pulumi.Input[str]]:
        """
        The direction of the control policy. Valid values: `in`, `out`.
        """
        return pulumi.get(self, "direction")

    @direction.setter
    def direction(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "direction", value)

    @property
    @pulumi.getter(name="newPrio")
    def new_prio(self) -> Optional[pulumi.Input[int]]:
        """
        The new priority of the control policy. The priority increases in order from 1, with lower priority indicating higher priority.
        """
        return pulumi.get(self, "new_prio")

    @new_prio.setter
    def new_prio(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "new_prio", value)

    @property
    @pulumi.getter
    def prio(self) -> Optional[pulumi.Input[int]]:
        """
        The priority of the control policy.
        """
        return pulumi.get(self, "prio")

    @prio.setter
    def prio(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "prio", value)

    @property
    @pulumi.getter(name="ruleId")
    def rule_id(self) -> Optional[pulumi.Input[str]]:
        """
        The rule id of the control policy.
        """
        return pulumi.get(self, "rule_id")

    @rule_id.setter
    def rule_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "rule_id", value)


class CfwControlPolicyPriority(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 direction: Optional[pulumi.Input[str]] = None,
                 new_prio: Optional[pulumi.Input[int]] = None,
                 rule_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to manage cfw control policy priority
        ## Example Usage

        ```python
        import pulumi
        import pulumi_volcengine as volcengine

        foo_cfw_address_book = volcengine.cloud_firewall.CfwAddressBook("fooCfwAddressBook",
            group_name="acc-test-address-book",
            description="acc-test",
            group_type="ip",
            address_lists=[
                "192.168.1.1",
                "192.168.2.2",
            ])
        foo_cfw_control_policy = volcengine.cloud_firewall.CfwControlPolicy("fooCfwControlPolicy",
            direction="in",
            action="accept",
            destination_type="group",
            destination=foo_cfw_address_book.id,
            proto="TCP",
            source_type="net",
            source="0.0.0.0/0",
            description="acc-test-control-policy",
            dest_port_type="port",
            dest_port="300",
            repeat_type="Weekly",
            repeat_start_time="01:00",
            repeat_end_time="11:00",
            repeat_days=[
                2,
                5,
            ],
            start_time=1736092800,
            end_time=1738339140,
            priority=1,
            status=True)
        foo_cfw_control_policy_priority = volcengine.cloud_firewall.CfwControlPolicyPriority("fooCfwControlPolicyPriority",
            direction="in",
            rule_id=foo_cfw_control_policy.rule_id,
            new_prio=5)
        ```

        ## Import

        ControlPolicyPriority can be imported using the direction:rule_id, e.g.

        ```sh
        $ pulumi import volcengine:cloud_firewall/cfwControlPolicyPriority:CfwControlPolicyPriority default resource_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] direction: The direction of the control policy. Valid values: `in`, `out`.
        :param pulumi.Input[int] new_prio: The new priority of the control policy. The priority increases in order from 1, with lower priority indicating higher priority.
        :param pulumi.Input[str] rule_id: The rule id of the control policy.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: CfwControlPolicyPriorityArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to manage cfw control policy priority
        ## Example Usage

        ```python
        import pulumi
        import pulumi_volcengine as volcengine

        foo_cfw_address_book = volcengine.cloud_firewall.CfwAddressBook("fooCfwAddressBook",
            group_name="acc-test-address-book",
            description="acc-test",
            group_type="ip",
            address_lists=[
                "192.168.1.1",
                "192.168.2.2",
            ])
        foo_cfw_control_policy = volcengine.cloud_firewall.CfwControlPolicy("fooCfwControlPolicy",
            direction="in",
            action="accept",
            destination_type="group",
            destination=foo_cfw_address_book.id,
            proto="TCP",
            source_type="net",
            source="0.0.0.0/0",
            description="acc-test-control-policy",
            dest_port_type="port",
            dest_port="300",
            repeat_type="Weekly",
            repeat_start_time="01:00",
            repeat_end_time="11:00",
            repeat_days=[
                2,
                5,
            ],
            start_time=1736092800,
            end_time=1738339140,
            priority=1,
            status=True)
        foo_cfw_control_policy_priority = volcengine.cloud_firewall.CfwControlPolicyPriority("fooCfwControlPolicyPriority",
            direction="in",
            rule_id=foo_cfw_control_policy.rule_id,
            new_prio=5)
        ```

        ## Import

        ControlPolicyPriority can be imported using the direction:rule_id, e.g.

        ```sh
        $ pulumi import volcengine:cloud_firewall/cfwControlPolicyPriority:CfwControlPolicyPriority default resource_id
        ```

        :param str resource_name: The name of the resource.
        :param CfwControlPolicyPriorityArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(CfwControlPolicyPriorityArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 direction: Optional[pulumi.Input[str]] = None,
                 new_prio: Optional[pulumi.Input[int]] = None,
                 rule_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = CfwControlPolicyPriorityArgs.__new__(CfwControlPolicyPriorityArgs)

            if direction is None and not opts.urn:
                raise TypeError("Missing required property 'direction'")
            __props__.__dict__["direction"] = direction
            __props__.__dict__["new_prio"] = new_prio
            if rule_id is None and not opts.urn:
                raise TypeError("Missing required property 'rule_id'")
            __props__.__dict__["rule_id"] = rule_id
            __props__.__dict__["prio"] = None
        super(CfwControlPolicyPriority, __self__).__init__(
            'volcengine:cloud_firewall/cfwControlPolicyPriority:CfwControlPolicyPriority',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            direction: Optional[pulumi.Input[str]] = None,
            new_prio: Optional[pulumi.Input[int]] = None,
            prio: Optional[pulumi.Input[int]] = None,
            rule_id: Optional[pulumi.Input[str]] = None) -> 'CfwControlPolicyPriority':
        """
        Get an existing CfwControlPolicyPriority resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] direction: The direction of the control policy. Valid values: `in`, `out`.
        :param pulumi.Input[int] new_prio: The new priority of the control policy. The priority increases in order from 1, with lower priority indicating higher priority.
        :param pulumi.Input[int] prio: The priority of the control policy.
        :param pulumi.Input[str] rule_id: The rule id of the control policy.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _CfwControlPolicyPriorityState.__new__(_CfwControlPolicyPriorityState)

        __props__.__dict__["direction"] = direction
        __props__.__dict__["new_prio"] = new_prio
        __props__.__dict__["prio"] = prio
        __props__.__dict__["rule_id"] = rule_id
        return CfwControlPolicyPriority(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def direction(self) -> pulumi.Output[str]:
        """
        The direction of the control policy. Valid values: `in`, `out`.
        """
        return pulumi.get(self, "direction")

    @property
    @pulumi.getter(name="newPrio")
    def new_prio(self) -> pulumi.Output[Optional[int]]:
        """
        The new priority of the control policy. The priority increases in order from 1, with lower priority indicating higher priority.
        """
        return pulumi.get(self, "new_prio")

    @property
    @pulumi.getter
    def prio(self) -> pulumi.Output[int]:
        """
        The priority of the control policy.
        """
        return pulumi.get(self, "prio")

    @property
    @pulumi.getter(name="ruleId")
    def rule_id(self) -> pulumi.Output[str]:
        """
        The rule id of the control policy.
        """
        return pulumi.get(self, "rule_id")

