# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['CfwVpcFirewallAclRulePriorityArgs', 'CfwVpcFirewallAclRulePriority']

@pulumi.input_type
class CfwVpcFirewallAclRulePriorityArgs:
    def __init__(__self__, *,
                 rule_id: pulumi.Input[str],
                 vpc_firewall_id: pulumi.Input[str],
                 new_prio: Optional[pulumi.Input[int]] = None):
        """
        The set of arguments for constructing a CfwVpcFirewallAclRulePriority resource.
        :param pulumi.Input[str] rule_id: The rule id of the vpc firewall acl rule.
        :param pulumi.Input[str] vpc_firewall_id: The id of the vpc firewall.
        :param pulumi.Input[int] new_prio: The new priority of the vpc firewall acl rule. The priority increases in order from 1, with lower priority indicating higher priority.
        """
        pulumi.set(__self__, "rule_id", rule_id)
        pulumi.set(__self__, "vpc_firewall_id", vpc_firewall_id)
        if new_prio is not None:
            pulumi.set(__self__, "new_prio", new_prio)

    @property
    @pulumi.getter(name="ruleId")
    def rule_id(self) -> pulumi.Input[str]:
        """
        The rule id of the vpc firewall acl rule.
        """
        return pulumi.get(self, "rule_id")

    @rule_id.setter
    def rule_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "rule_id", value)

    @property
    @pulumi.getter(name="vpcFirewallId")
    def vpc_firewall_id(self) -> pulumi.Input[str]:
        """
        The id of the vpc firewall.
        """
        return pulumi.get(self, "vpc_firewall_id")

    @vpc_firewall_id.setter
    def vpc_firewall_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "vpc_firewall_id", value)

    @property
    @pulumi.getter(name="newPrio")
    def new_prio(self) -> Optional[pulumi.Input[int]]:
        """
        The new priority of the vpc firewall acl rule. The priority increases in order from 1, with lower priority indicating higher priority.
        """
        return pulumi.get(self, "new_prio")

    @new_prio.setter
    def new_prio(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "new_prio", value)


@pulumi.input_type
class _CfwVpcFirewallAclRulePriorityState:
    def __init__(__self__, *,
                 new_prio: Optional[pulumi.Input[int]] = None,
                 prio: Optional[pulumi.Input[int]] = None,
                 rule_id: Optional[pulumi.Input[str]] = None,
                 vpc_firewall_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering CfwVpcFirewallAclRulePriority resources.
        :param pulumi.Input[int] new_prio: The new priority of the vpc firewall acl rule. The priority increases in order from 1, with lower priority indicating higher priority.
        :param pulumi.Input[int] prio: The priority of the vpc firewall acl rule.
        :param pulumi.Input[str] rule_id: The rule id of the vpc firewall acl rule.
        :param pulumi.Input[str] vpc_firewall_id: The id of the vpc firewall.
        """
        if new_prio is not None:
            pulumi.set(__self__, "new_prio", new_prio)
        if prio is not None:
            pulumi.set(__self__, "prio", prio)
        if rule_id is not None:
            pulumi.set(__self__, "rule_id", rule_id)
        if vpc_firewall_id is not None:
            pulumi.set(__self__, "vpc_firewall_id", vpc_firewall_id)

    @property
    @pulumi.getter(name="newPrio")
    def new_prio(self) -> Optional[pulumi.Input[int]]:
        """
        The new priority of the vpc firewall acl rule. The priority increases in order from 1, with lower priority indicating higher priority.
        """
        return pulumi.get(self, "new_prio")

    @new_prio.setter
    def new_prio(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "new_prio", value)

    @property
    @pulumi.getter
    def prio(self) -> Optional[pulumi.Input[int]]:
        """
        The priority of the vpc firewall acl rule.
        """
        return pulumi.get(self, "prio")

    @prio.setter
    def prio(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "prio", value)

    @property
    @pulumi.getter(name="ruleId")
    def rule_id(self) -> Optional[pulumi.Input[str]]:
        """
        The rule id of the vpc firewall acl rule.
        """
        return pulumi.get(self, "rule_id")

    @rule_id.setter
    def rule_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "rule_id", value)

    @property
    @pulumi.getter(name="vpcFirewallId")
    def vpc_firewall_id(self) -> Optional[pulumi.Input[str]]:
        """
        The id of the vpc firewall.
        """
        return pulumi.get(self, "vpc_firewall_id")

    @vpc_firewall_id.setter
    def vpc_firewall_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vpc_firewall_id", value)


class CfwVpcFirewallAclRulePriority(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 new_prio: Optional[pulumi.Input[int]] = None,
                 rule_id: Optional[pulumi.Input[str]] = None,
                 vpc_firewall_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to manage cfw vpc firewall acl rule priority
        ## Example Usage

        ```python
        import pulumi
        import pulumi_volcengine as volcengine

        foo_cfw_address_book = volcengine.cloud_firewall.CfwAddressBook("fooCfwAddressBook",
            group_name="acc-test-address-book",
            description="acc-test",
            group_type="ip",
            address_lists=[
                "192.168.1.1",
                "192.168.2.2",
            ])
        foo_cfw_vpc_firewall_acl_rule = volcengine.cloud_firewall.CfwVpcFirewallAclRule("fooCfwVpcFirewallAclRule",
            vpc_firewall_id="vfw-ydmjakzksgf7u99j****",
            action="accept",
            destination_type="group",
            destination=foo_cfw_address_book.id,
            proto="TCP",
            source_type="net",
            source="0.0.0.0/0",
            description="acc-test-control-policy",
            dest_port_type="port",
            dest_port="300",
            repeat_type="Weekly",
            repeat_start_time="01:00",
            repeat_end_time="11:00",
            repeat_days=[
                2,
                5,
            ],
            start_time=1736092800,
            end_time=1738339140,
            priority=1,
            status=True)
        foo_cfw_vpc_firewall_acl_rule_priority = volcengine.cloud_firewall.CfwVpcFirewallAclRulePriority("fooCfwVpcFirewallAclRulePriority",
            vpc_firewall_id="vfw-ydmjakzksgf7u99j****",
            rule_id=foo_cfw_vpc_firewall_acl_rule.rule_id,
            new_prio=3)
        ```

        ## Import

        VpcFirewallAclRulePriority can be imported using the vpc_firewall_id:rule_id, e.g.

        ```sh
        $ pulumi import volcengine:cloud_firewall/cfwVpcFirewallAclRulePriority:CfwVpcFirewallAclRulePriority default resource_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] new_prio: The new priority of the vpc firewall acl rule. The priority increases in order from 1, with lower priority indicating higher priority.
        :param pulumi.Input[str] rule_id: The rule id of the vpc firewall acl rule.
        :param pulumi.Input[str] vpc_firewall_id: The id of the vpc firewall.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: CfwVpcFirewallAclRulePriorityArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to manage cfw vpc firewall acl rule priority
        ## Example Usage

        ```python
        import pulumi
        import pulumi_volcengine as volcengine

        foo_cfw_address_book = volcengine.cloud_firewall.CfwAddressBook("fooCfwAddressBook",
            group_name="acc-test-address-book",
            description="acc-test",
            group_type="ip",
            address_lists=[
                "192.168.1.1",
                "192.168.2.2",
            ])
        foo_cfw_vpc_firewall_acl_rule = volcengine.cloud_firewall.CfwVpcFirewallAclRule("fooCfwVpcFirewallAclRule",
            vpc_firewall_id="vfw-ydmjakzksgf7u99j****",
            action="accept",
            destination_type="group",
            destination=foo_cfw_address_book.id,
            proto="TCP",
            source_type="net",
            source="0.0.0.0/0",
            description="acc-test-control-policy",
            dest_port_type="port",
            dest_port="300",
            repeat_type="Weekly",
            repeat_start_time="01:00",
            repeat_end_time="11:00",
            repeat_days=[
                2,
                5,
            ],
            start_time=1736092800,
            end_time=1738339140,
            priority=1,
            status=True)
        foo_cfw_vpc_firewall_acl_rule_priority = volcengine.cloud_firewall.CfwVpcFirewallAclRulePriority("fooCfwVpcFirewallAclRulePriority",
            vpc_firewall_id="vfw-ydmjakzksgf7u99j****",
            rule_id=foo_cfw_vpc_firewall_acl_rule.rule_id,
            new_prio=3)
        ```

        ## Import

        VpcFirewallAclRulePriority can be imported using the vpc_firewall_id:rule_id, e.g.

        ```sh
        $ pulumi import volcengine:cloud_firewall/cfwVpcFirewallAclRulePriority:CfwVpcFirewallAclRulePriority default resource_id
        ```

        :param str resource_name: The name of the resource.
        :param CfwVpcFirewallAclRulePriorityArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(CfwVpcFirewallAclRulePriorityArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 new_prio: Optional[pulumi.Input[int]] = None,
                 rule_id: Optional[pulumi.Input[str]] = None,
                 vpc_firewall_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = CfwVpcFirewallAclRulePriorityArgs.__new__(CfwVpcFirewallAclRulePriorityArgs)

            __props__.__dict__["new_prio"] = new_prio
            if rule_id is None and not opts.urn:
                raise TypeError("Missing required property 'rule_id'")
            __props__.__dict__["rule_id"] = rule_id
            if vpc_firewall_id is None and not opts.urn:
                raise TypeError("Missing required property 'vpc_firewall_id'")
            __props__.__dict__["vpc_firewall_id"] = vpc_firewall_id
            __props__.__dict__["prio"] = None
        super(CfwVpcFirewallAclRulePriority, __self__).__init__(
            'volcengine:cloud_firewall/cfwVpcFirewallAclRulePriority:CfwVpcFirewallAclRulePriority',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            new_prio: Optional[pulumi.Input[int]] = None,
            prio: Optional[pulumi.Input[int]] = None,
            rule_id: Optional[pulumi.Input[str]] = None,
            vpc_firewall_id: Optional[pulumi.Input[str]] = None) -> 'CfwVpcFirewallAclRulePriority':
        """
        Get an existing CfwVpcFirewallAclRulePriority resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] new_prio: The new priority of the vpc firewall acl rule. The priority increases in order from 1, with lower priority indicating higher priority.
        :param pulumi.Input[int] prio: The priority of the vpc firewall acl rule.
        :param pulumi.Input[str] rule_id: The rule id of the vpc firewall acl rule.
        :param pulumi.Input[str] vpc_firewall_id: The id of the vpc firewall.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _CfwVpcFirewallAclRulePriorityState.__new__(_CfwVpcFirewallAclRulePriorityState)

        __props__.__dict__["new_prio"] = new_prio
        __props__.__dict__["prio"] = prio
        __props__.__dict__["rule_id"] = rule_id
        __props__.__dict__["vpc_firewall_id"] = vpc_firewall_id
        return CfwVpcFirewallAclRulePriority(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="newPrio")
    def new_prio(self) -> pulumi.Output[Optional[int]]:
        """
        The new priority of the vpc firewall acl rule. The priority increases in order from 1, with lower priority indicating higher priority.
        """
        return pulumi.get(self, "new_prio")

    @property
    @pulumi.getter
    def prio(self) -> pulumi.Output[int]:
        """
        The priority of the vpc firewall acl rule.
        """
        return pulumi.get(self, "prio")

    @property
    @pulumi.getter(name="ruleId")
    def rule_id(self) -> pulumi.Output[str]:
        """
        The rule id of the vpc firewall acl rule.
        """
        return pulumi.get(self, "rule_id")

    @property
    @pulumi.getter(name="vpcFirewallId")
    def vpc_firewall_id(self) -> pulumi.Output[str]:
        """
        The id of the vpc firewall.
        """
        return pulumi.get(self, "vpc_firewall_id")

