# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetEscloudInstancesV2Result',
    'AwaitableGetEscloudInstancesV2Result',
    'get_escloud_instances_v2',
    'get_escloud_instances_v2_output',
]

@pulumi.output_type
class GetEscloudInstancesV2Result:
    """
    A collection of values returned by getEscloudInstancesV2.
    """
    def __init__(__self__, charge_types=None, id=None, ids=None, instance_names=None, instances=None, output_file=None, project_name=None, statuses=None, tags=None, total_count=None, versions=None, zone_ids=None):
        if charge_types and not isinstance(charge_types, list):
            raise TypeError("Expected argument 'charge_types' to be a list")
        pulumi.set(__self__, "charge_types", charge_types)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if ids and not isinstance(ids, list):
            raise TypeError("Expected argument 'ids' to be a list")
        pulumi.set(__self__, "ids", ids)
        if instance_names and not isinstance(instance_names, list):
            raise TypeError("Expected argument 'instance_names' to be a list")
        pulumi.set(__self__, "instance_names", instance_names)
        if instances and not isinstance(instances, list):
            raise TypeError("Expected argument 'instances' to be a list")
        pulumi.set(__self__, "instances", instances)
        if output_file and not isinstance(output_file, str):
            raise TypeError("Expected argument 'output_file' to be a str")
        pulumi.set(__self__, "output_file", output_file)
        if project_name and not isinstance(project_name, str):
            raise TypeError("Expected argument 'project_name' to be a str")
        pulumi.set(__self__, "project_name", project_name)
        if statuses and not isinstance(statuses, list):
            raise TypeError("Expected argument 'statuses' to be a list")
        pulumi.set(__self__, "statuses", statuses)
        if tags and not isinstance(tags, list):
            raise TypeError("Expected argument 'tags' to be a list")
        pulumi.set(__self__, "tags", tags)
        if total_count and not isinstance(total_count, int):
            raise TypeError("Expected argument 'total_count' to be a int")
        pulumi.set(__self__, "total_count", total_count)
        if versions and not isinstance(versions, list):
            raise TypeError("Expected argument 'versions' to be a list")
        pulumi.set(__self__, "versions", versions)
        if zone_ids and not isinstance(zone_ids, list):
            raise TypeError("Expected argument 'zone_ids' to be a list")
        pulumi.set(__self__, "zone_ids", zone_ids)

    @property
    @pulumi.getter(name="chargeTypes")
    def charge_types(self) -> Optional[Sequence[str]]:
        return pulumi.get(self, "charge_types")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def ids(self) -> Optional[Sequence[str]]:
        return pulumi.get(self, "ids")

    @property
    @pulumi.getter(name="instanceNames")
    def instance_names(self) -> Optional[Sequence[str]]:
        return pulumi.get(self, "instance_names")

    @property
    @pulumi.getter
    def instances(self) -> Sequence['outputs.GetEscloudInstancesV2InstanceResult']:
        """
        The collection of query.
        """
        return pulumi.get(self, "instances")

    @property
    @pulumi.getter(name="outputFile")
    def output_file(self) -> Optional[str]:
        return pulumi.get(self, "output_file")

    @property
    @pulumi.getter(name="projectName")
    def project_name(self) -> Optional[str]:
        """
        The name of project.
        """
        return pulumi.get(self, "project_name")

    @property
    @pulumi.getter
    def statuses(self) -> Optional[Sequence[str]]:
        return pulumi.get(self, "statuses")

    @property
    @pulumi.getter
    def tags(self) -> Optional[Sequence['outputs.GetEscloudInstancesV2TagResult']]:
        """
        Tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter(name="totalCount")
    def total_count(self) -> int:
        """
        The total count of query.
        """
        return pulumi.get(self, "total_count")

    @property
    @pulumi.getter
    def versions(self) -> Optional[Sequence[str]]:
        return pulumi.get(self, "versions")

    @property
    @pulumi.getter(name="zoneIds")
    def zone_ids(self) -> Optional[Sequence[str]]:
        return pulumi.get(self, "zone_ids")


class AwaitableGetEscloudInstancesV2Result(GetEscloudInstancesV2Result):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetEscloudInstancesV2Result(
            charge_types=self.charge_types,
            id=self.id,
            ids=self.ids,
            instance_names=self.instance_names,
            instances=self.instances,
            output_file=self.output_file,
            project_name=self.project_name,
            statuses=self.statuses,
            tags=self.tags,
            total_count=self.total_count,
            versions=self.versions,
            zone_ids=self.zone_ids)


def get_escloud_instances_v2(charge_types: Optional[Sequence[str]] = None,
                             ids: Optional[Sequence[str]] = None,
                             instance_names: Optional[Sequence[str]] = None,
                             output_file: Optional[str] = None,
                             project_name: Optional[str] = None,
                             statuses: Optional[Sequence[str]] = None,
                             tags: Optional[Sequence[pulumi.InputType['GetEscloudInstancesV2TagArgs']]] = None,
                             versions: Optional[Sequence[str]] = None,
                             zone_ids: Optional[Sequence[str]] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetEscloudInstancesV2Result:
    """
    Use this data source to query detailed information of escloud instances v2
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo_zones = volcengine.ecs.get_zones()
    foo_vpc = volcengine.vpc.Vpc("fooVpc",
        vpc_name="acc-test-vpc",
        cidr_block="172.16.0.0/16")
    foo_subnet = volcengine.vpc.Subnet("fooSubnet",
        subnet_name="acc-test-subnet",
        description="tfdesc",
        cidr_block="172.16.0.0/24",
        zone_id=foo_zones.zones[0].id,
        vpc_id=foo_vpc.id)
    foo_escloud_instance_v2 = volcengine.escloud_v2.EscloudInstanceV2("fooEscloudInstanceV2",
        instance_name="acc-test-escloud-instance",
        version="V7_10",
        zone_ids=[
            foo_zones.zones[0].id,
            foo_zones.zones[1].id,
            foo_zones.zones[2].id,
        ],
        subnet_id=foo_subnet.id,
        enable_https=False,
        admin_password="Password@@123",
        charge_type="PostPaid",
        auto_renew=False,
        period=1,
        configuration_code="es.standard",
        enable_pure_master=True,
        deletion_protection=False,
        project_name="default",
        node_specs_assigns=[
            volcengine.escloud_v2.EscloudInstanceV2NodeSpecsAssignArgs(
                type="Master",
                number=3,
                resource_spec_name="es.x2.medium",
                storage_spec_name="es.volume.essd.pl0",
                storage_size=20,
            ),
            volcengine.escloud_v2.EscloudInstanceV2NodeSpecsAssignArgs(
                type="Hot",
                number=6,
                resource_spec_name="es.x2.medium",
                storage_spec_name="es.volume.essd.flexpl-standard",
                storage_size=500,
                extra_performance=volcengine.escloud_v2.EscloudInstanceV2NodeSpecsAssignExtraPerformanceArgs(
                    throughput=65,
                ),
            ),
            volcengine.escloud_v2.EscloudInstanceV2NodeSpecsAssignArgs(
                type="Kibana",
                number=1,
                resource_spec_name="kibana.x2.small",
                storage_spec_name="",
                storage_size=0,
            ),
        ],
        network_specs=[
            volcengine.escloud_v2.EscloudInstanceV2NetworkSpecArgs(
                type="Elasticsearch",
                bandwidth=1,
                is_open=True,
                spec_name="es.eip.bgp_fixed_bandwidth",
            ),
            volcengine.escloud_v2.EscloudInstanceV2NetworkSpecArgs(
                type="Kibana",
                bandwidth=1,
                is_open=True,
                spec_name="es.eip.bgp_fixed_bandwidth",
            ),
        ],
        tags=[volcengine.escloud_v2.EscloudInstanceV2TagArgs(
            key="k1",
            value="v1",
        )])
    foo_escloud_instances_v2 = volcengine.escloud_v2.get_escloud_instances_v2_output(ids=[foo_escloud_instance_v2.id])
    ```


    :param Sequence[str] charge_types: The charge types of instance.
    :param Sequence[str] ids: A list of instance IDs.
    :param Sequence[str] instance_names: The names of instance.
    :param str output_file: File name where to save data source results.
    :param str project_name: The project name of instance.
    :param Sequence[str] statuses: The status of instance.
    :param Sequence[pulumi.InputType['GetEscloudInstancesV2TagArgs']] tags: The tags of instance.
    :param Sequence[str] versions: The versions of instance.
    :param Sequence[str] zone_ids: The available zone IDs of instance.
    """
    __args__ = dict()
    __args__['chargeTypes'] = charge_types
    __args__['ids'] = ids
    __args__['instanceNames'] = instance_names
    __args__['outputFile'] = output_file
    __args__['projectName'] = project_name
    __args__['statuses'] = statuses
    __args__['tags'] = tags
    __args__['versions'] = versions
    __args__['zoneIds'] = zone_ids
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('volcengine:escloud_v2/getEscloudInstancesV2:getEscloudInstancesV2', __args__, opts=opts, typ=GetEscloudInstancesV2Result).value

    return AwaitableGetEscloudInstancesV2Result(
        charge_types=pulumi.get(__ret__, 'charge_types'),
        id=pulumi.get(__ret__, 'id'),
        ids=pulumi.get(__ret__, 'ids'),
        instance_names=pulumi.get(__ret__, 'instance_names'),
        instances=pulumi.get(__ret__, 'instances'),
        output_file=pulumi.get(__ret__, 'output_file'),
        project_name=pulumi.get(__ret__, 'project_name'),
        statuses=pulumi.get(__ret__, 'statuses'),
        tags=pulumi.get(__ret__, 'tags'),
        total_count=pulumi.get(__ret__, 'total_count'),
        versions=pulumi.get(__ret__, 'versions'),
        zone_ids=pulumi.get(__ret__, 'zone_ids'))


@_utilities.lift_output_func(get_escloud_instances_v2)
def get_escloud_instances_v2_output(charge_types: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                                    ids: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                                    instance_names: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                                    output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                    project_name: Optional[pulumi.Input[Optional[str]]] = None,
                                    statuses: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                                    tags: Optional[pulumi.Input[Optional[Sequence[pulumi.InputType['GetEscloudInstancesV2TagArgs']]]]] = None,
                                    versions: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                                    zone_ids: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                                    opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetEscloudInstancesV2Result]:
    """
    Use this data source to query detailed information of escloud instances v2
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo_zones = volcengine.ecs.get_zones()
    foo_vpc = volcengine.vpc.Vpc("fooVpc",
        vpc_name="acc-test-vpc",
        cidr_block="172.16.0.0/16")
    foo_subnet = volcengine.vpc.Subnet("fooSubnet",
        subnet_name="acc-test-subnet",
        description="tfdesc",
        cidr_block="172.16.0.0/24",
        zone_id=foo_zones.zones[0].id,
        vpc_id=foo_vpc.id)
    foo_escloud_instance_v2 = volcengine.escloud_v2.EscloudInstanceV2("fooEscloudInstanceV2",
        instance_name="acc-test-escloud-instance",
        version="V7_10",
        zone_ids=[
            foo_zones.zones[0].id,
            foo_zones.zones[1].id,
            foo_zones.zones[2].id,
        ],
        subnet_id=foo_subnet.id,
        enable_https=False,
        admin_password="Password@@123",
        charge_type="PostPaid",
        auto_renew=False,
        period=1,
        configuration_code="es.standard",
        enable_pure_master=True,
        deletion_protection=False,
        project_name="default",
        node_specs_assigns=[
            volcengine.escloud_v2.EscloudInstanceV2NodeSpecsAssignArgs(
                type="Master",
                number=3,
                resource_spec_name="es.x2.medium",
                storage_spec_name="es.volume.essd.pl0",
                storage_size=20,
            ),
            volcengine.escloud_v2.EscloudInstanceV2NodeSpecsAssignArgs(
                type="Hot",
                number=6,
                resource_spec_name="es.x2.medium",
                storage_spec_name="es.volume.essd.flexpl-standard",
                storage_size=500,
                extra_performance=volcengine.escloud_v2.EscloudInstanceV2NodeSpecsAssignExtraPerformanceArgs(
                    throughput=65,
                ),
            ),
            volcengine.escloud_v2.EscloudInstanceV2NodeSpecsAssignArgs(
                type="Kibana",
                number=1,
                resource_spec_name="kibana.x2.small",
                storage_spec_name="",
                storage_size=0,
            ),
        ],
        network_specs=[
            volcengine.escloud_v2.EscloudInstanceV2NetworkSpecArgs(
                type="Elasticsearch",
                bandwidth=1,
                is_open=True,
                spec_name="es.eip.bgp_fixed_bandwidth",
            ),
            volcengine.escloud_v2.EscloudInstanceV2NetworkSpecArgs(
                type="Kibana",
                bandwidth=1,
                is_open=True,
                spec_name="es.eip.bgp_fixed_bandwidth",
            ),
        ],
        tags=[volcengine.escloud_v2.EscloudInstanceV2TagArgs(
            key="k1",
            value="v1",
        )])
    foo_escloud_instances_v2 = volcengine.escloud_v2.get_escloud_instances_v2_output(ids=[foo_escloud_instance_v2.id])
    ```


    :param Sequence[str] charge_types: The charge types of instance.
    :param Sequence[str] ids: A list of instance IDs.
    :param Sequence[str] instance_names: The names of instance.
    :param str output_file: File name where to save data source results.
    :param str project_name: The project name of instance.
    :param Sequence[str] statuses: The status of instance.
    :param Sequence[pulumi.InputType['GetEscloudInstancesV2TagArgs']] tags: The tags of instance.
    :param Sequence[str] versions: The versions of instance.
    :param Sequence[str] zone_ids: The available zone IDs of instance.
    """
    ...
