# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetEscloudZonesV2Result',
    'AwaitableGetEscloudZonesV2Result',
    'get_escloud_zones_v2',
    'get_escloud_zones_v2_output',
]

@pulumi.output_type
class GetEscloudZonesV2Result:
    """
    A collection of values returned by getEscloudZonesV2.
    """
    def __init__(__self__, id=None, output_file=None, total_count=None, zones=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if output_file and not isinstance(output_file, str):
            raise TypeError("Expected argument 'output_file' to be a str")
        pulumi.set(__self__, "output_file", output_file)
        if total_count and not isinstance(total_count, int):
            raise TypeError("Expected argument 'total_count' to be a int")
        pulumi.set(__self__, "total_count", total_count)
        if zones and not isinstance(zones, list):
            raise TypeError("Expected argument 'zones' to be a list")
        pulumi.set(__self__, "zones", zones)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="outputFile")
    def output_file(self) -> Optional[str]:
        return pulumi.get(self, "output_file")

    @property
    @pulumi.getter(name="totalCount")
    def total_count(self) -> int:
        """
        The total count of query.
        """
        return pulumi.get(self, "total_count")

    @property
    @pulumi.getter
    def zones(self) -> Sequence['outputs.GetEscloudZonesV2ZoneResult']:
        """
        The collection of query.
        """
        return pulumi.get(self, "zones")


class AwaitableGetEscloudZonesV2Result(GetEscloudZonesV2Result):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetEscloudZonesV2Result(
            id=self.id,
            output_file=self.output_file,
            total_count=self.total_count,
            zones=self.zones)


def get_escloud_zones_v2(output_file: Optional[str] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetEscloudZonesV2Result:
    """
    Use this data source to query detailed information of escloud zones v2
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo = volcengine.escloud_v2.get_escloud_zones_v2()
    ```


    :param str output_file: File name where to save data source results.
    """
    __args__ = dict()
    __args__['outputFile'] = output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('volcengine:escloud_v2/getEscloudZonesV2:getEscloudZonesV2', __args__, opts=opts, typ=GetEscloudZonesV2Result).value

    return AwaitableGetEscloudZonesV2Result(
        id=pulumi.get(__ret__, 'id'),
        output_file=pulumi.get(__ret__, 'output_file'),
        total_count=pulumi.get(__ret__, 'total_count'),
        zones=pulumi.get(__ret__, 'zones'))


@_utilities.lift_output_func(get_escloud_zones_v2)
def get_escloud_zones_v2_output(output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetEscloudZonesV2Result]:
    """
    Use this data source to query detailed information of escloud zones v2
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo = volcengine.escloud_v2.get_escloud_zones_v2()
    ```


    :param str output_file: File name where to save data source results.
    """
    ...
