# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetKeyringsResult',
    'AwaitableGetKeyringsResult',
    'get_keyrings',
    'get_keyrings_output',
]

@pulumi.output_type
class GetKeyringsResult:
    """
    A collection of values returned by getKeyrings.
    """
    def __init__(__self__, creation_date_ranges=None, descriptions=None, id=None, keyring_names=None, keyring_types=None, keyrings=None, name_regex=None, output_file=None, project_name=None, total_count=None, update_date_ranges=None):
        if creation_date_ranges and not isinstance(creation_date_ranges, list):
            raise TypeError("Expected argument 'creation_date_ranges' to be a list")
        pulumi.set(__self__, "creation_date_ranges", creation_date_ranges)
        if descriptions and not isinstance(descriptions, list):
            raise TypeError("Expected argument 'descriptions' to be a list")
        pulumi.set(__self__, "descriptions", descriptions)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if keyring_names and not isinstance(keyring_names, list):
            raise TypeError("Expected argument 'keyring_names' to be a list")
        pulumi.set(__self__, "keyring_names", keyring_names)
        if keyring_types and not isinstance(keyring_types, list):
            raise TypeError("Expected argument 'keyring_types' to be a list")
        pulumi.set(__self__, "keyring_types", keyring_types)
        if keyrings and not isinstance(keyrings, list):
            raise TypeError("Expected argument 'keyrings' to be a list")
        pulumi.set(__self__, "keyrings", keyrings)
        if name_regex and not isinstance(name_regex, str):
            raise TypeError("Expected argument 'name_regex' to be a str")
        pulumi.set(__self__, "name_regex", name_regex)
        if output_file and not isinstance(output_file, str):
            raise TypeError("Expected argument 'output_file' to be a str")
        pulumi.set(__self__, "output_file", output_file)
        if project_name and not isinstance(project_name, str):
            raise TypeError("Expected argument 'project_name' to be a str")
        pulumi.set(__self__, "project_name", project_name)
        if total_count and not isinstance(total_count, int):
            raise TypeError("Expected argument 'total_count' to be a int")
        pulumi.set(__self__, "total_count", total_count)
        if update_date_ranges and not isinstance(update_date_ranges, list):
            raise TypeError("Expected argument 'update_date_ranges' to be a list")
        pulumi.set(__self__, "update_date_ranges", update_date_ranges)

    @property
    @pulumi.getter(name="creationDateRanges")
    def creation_date_ranges(self) -> Optional[Sequence[str]]:
        return pulumi.get(self, "creation_date_ranges")

    @property
    @pulumi.getter
    def descriptions(self) -> Optional[Sequence[str]]:
        """
        The description of the keyring.
        """
        return pulumi.get(self, "descriptions")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="keyringNames")
    def keyring_names(self) -> Optional[Sequence[str]]:
        """
        The name of the keyring.
        """
        return pulumi.get(self, "keyring_names")

    @property
    @pulumi.getter(name="keyringTypes")
    def keyring_types(self) -> Optional[Sequence[str]]:
        """
        The type of the keyring.
        """
        return pulumi.get(self, "keyring_types")

    @property
    @pulumi.getter
    def keyrings(self) -> Sequence['outputs.GetKeyringsKeyringResult']:
        """
        The information about the keyring.
        """
        return pulumi.get(self, "keyrings")

    @property
    @pulumi.getter(name="nameRegex")
    def name_regex(self) -> Optional[str]:
        return pulumi.get(self, "name_regex")

    @property
    @pulumi.getter(name="outputFile")
    def output_file(self) -> Optional[str]:
        return pulumi.get(self, "output_file")

    @property
    @pulumi.getter(name="projectName")
    def project_name(self) -> Optional[str]:
        return pulumi.get(self, "project_name")

    @property
    @pulumi.getter(name="totalCount")
    def total_count(self) -> int:
        """
        The total count of query.
        """
        return pulumi.get(self, "total_count")

    @property
    @pulumi.getter(name="updateDateRanges")
    def update_date_ranges(self) -> Optional[Sequence[str]]:
        return pulumi.get(self, "update_date_ranges")


class AwaitableGetKeyringsResult(GetKeyringsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetKeyringsResult(
            creation_date_ranges=self.creation_date_ranges,
            descriptions=self.descriptions,
            id=self.id,
            keyring_names=self.keyring_names,
            keyring_types=self.keyring_types,
            keyrings=self.keyrings,
            name_regex=self.name_regex,
            output_file=self.output_file,
            project_name=self.project_name,
            total_count=self.total_count,
            update_date_ranges=self.update_date_ranges)


def get_keyrings(creation_date_ranges: Optional[Sequence[str]] = None,
                 descriptions: Optional[Sequence[str]] = None,
                 keyring_names: Optional[Sequence[str]] = None,
                 keyring_types: Optional[Sequence[str]] = None,
                 name_regex: Optional[str] = None,
                 output_file: Optional[str] = None,
                 project_name: Optional[str] = None,
                 update_date_ranges: Optional[Sequence[str]] = None,
                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetKeyringsResult:
    """
    Use this data source to query detailed information of kms keyrings
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    default = volcengine.kms.get_keyrings(descriptions=[
            "tf-1",
            "tf-2",
        ],
        keyring_names=[
            "tf-test-1",
            "tf-test-2",
            "tf-test-3",
        ])
    ```


    :param Sequence[str] creation_date_ranges: The creation date of the keyring.
    :param Sequence[str] descriptions: The description of the keyring.
    :param Sequence[str] keyring_names: The name of the keyring.
    :param Sequence[str] keyring_types: The type of the keyring.
    :param str name_regex: A Name Regex of Resource.
    :param str output_file: File name where to save data source results.
    :param str project_name: The name of the project.
    :param Sequence[str] update_date_ranges: The update date of the keyring.
    """
    __args__ = dict()
    __args__['creationDateRanges'] = creation_date_ranges
    __args__['descriptions'] = descriptions
    __args__['keyringNames'] = keyring_names
    __args__['keyringTypes'] = keyring_types
    __args__['nameRegex'] = name_regex
    __args__['outputFile'] = output_file
    __args__['projectName'] = project_name
    __args__['updateDateRanges'] = update_date_ranges
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('volcengine:kms/getKeyrings:getKeyrings', __args__, opts=opts, typ=GetKeyringsResult).value

    return AwaitableGetKeyringsResult(
        creation_date_ranges=pulumi.get(__ret__, 'creation_date_ranges'),
        descriptions=pulumi.get(__ret__, 'descriptions'),
        id=pulumi.get(__ret__, 'id'),
        keyring_names=pulumi.get(__ret__, 'keyring_names'),
        keyring_types=pulumi.get(__ret__, 'keyring_types'),
        keyrings=pulumi.get(__ret__, 'keyrings'),
        name_regex=pulumi.get(__ret__, 'name_regex'),
        output_file=pulumi.get(__ret__, 'output_file'),
        project_name=pulumi.get(__ret__, 'project_name'),
        total_count=pulumi.get(__ret__, 'total_count'),
        update_date_ranges=pulumi.get(__ret__, 'update_date_ranges'))


@_utilities.lift_output_func(get_keyrings)
def get_keyrings_output(creation_date_ranges: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                        descriptions: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                        keyring_names: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                        keyring_types: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                        name_regex: Optional[pulumi.Input[Optional[str]]] = None,
                        output_file: Optional[pulumi.Input[Optional[str]]] = None,
                        project_name: Optional[pulumi.Input[Optional[str]]] = None,
                        update_date_ranges: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetKeyringsResult]:
    """
    Use this data source to query detailed information of kms keyrings
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    default = volcengine.kms.get_keyrings(descriptions=[
            "tf-1",
            "tf-2",
        ],
        keyring_names=[
            "tf-test-1",
            "tf-test-2",
            "tf-test-3",
        ])
    ```


    :param Sequence[str] creation_date_ranges: The creation date of the keyring.
    :param Sequence[str] descriptions: The description of the keyring.
    :param Sequence[str] keyring_names: The name of the keyring.
    :param Sequence[str] keyring_types: The type of the keyring.
    :param str name_regex: A Name Regex of Resource.
    :param str output_file: File name where to save data source results.
    :param str project_name: The name of the project.
    :param Sequence[str] update_date_ranges: The update date of the keyring.
    """
    ...
