# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetUnitsResult',
    'AwaitableGetUnitsResult',
    'get_units',
    'get_units_output',
]

@pulumi.output_type
class GetUnitsResult:
    """
    A collection of values returned by getUnits.
    """
    def __init__(__self__, id=None, output_file=None, total_count=None, units=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if output_file and not isinstance(output_file, str):
            raise TypeError("Expected argument 'output_file' to be a str")
        pulumi.set(__self__, "output_file", output_file)
        if total_count and not isinstance(total_count, int):
            raise TypeError("Expected argument 'total_count' to be a int")
        pulumi.set(__self__, "total_count", total_count)
        if units and not isinstance(units, list):
            raise TypeError("Expected argument 'units' to be a list")
        pulumi.set(__self__, "units", units)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="outputFile")
    def output_file(self) -> Optional[str]:
        return pulumi.get(self, "output_file")

    @property
    @pulumi.getter(name="totalCount")
    def total_count(self) -> int:
        """
        The total count of query.
        """
        return pulumi.get(self, "total_count")

    @property
    @pulumi.getter
    def units(self) -> Sequence['outputs.GetUnitsUnitResult']:
        """
        The collection of query.
        """
        return pulumi.get(self, "units")


class AwaitableGetUnitsResult(GetUnitsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetUnitsResult(
            id=self.id,
            output_file=self.output_file,
            total_count=self.total_count,
            units=self.units)


def get_units(output_file: Optional[str] = None,
              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetUnitsResult:
    """
    Use this data source to query detailed information of organization units
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo = volcengine.organization.get_units()
    ```


    :param str output_file: File name where to save data source results.
    """
    __args__ = dict()
    __args__['outputFile'] = output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('volcengine:organization/getUnits:getUnits', __args__, opts=opts, typ=GetUnitsResult).value

    return AwaitableGetUnitsResult(
        id=pulumi.get(__ret__, 'id'),
        output_file=pulumi.get(__ret__, 'output_file'),
        total_count=pulumi.get(__ret__, 'total_count'),
        units=pulumi.get(__ret__, 'units'))


@_utilities.lift_output_func(get_units)
def get_units_output(output_file: Optional[pulumi.Input[Optional[str]]] = None,
                     opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetUnitsResult]:
    """
    Use this data source to query detailed information of organization units
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo = volcengine.organization.get_units()
    ```


    :param str output_file: File name where to save data source results.
    """
    ...
