# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetInstancePluginsResult',
    'AwaitableGetInstancePluginsResult',
    'get_instance_plugins',
    'get_instance_plugins_output',
]

@pulumi.output_type
class GetInstancePluginsResult:
    """
    A collection of values returned by getInstancePlugins.
    """
    def __init__(__self__, id=None, instance_id=None, name_regex=None, output_file=None, plugins=None, total_count=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if name_regex and not isinstance(name_regex, str):
            raise TypeError("Expected argument 'name_regex' to be a str")
        pulumi.set(__self__, "name_regex", name_regex)
        if output_file and not isinstance(output_file, str):
            raise TypeError("Expected argument 'output_file' to be a str")
        pulumi.set(__self__, "output_file", output_file)
        if plugins and not isinstance(plugins, list):
            raise TypeError("Expected argument 'plugins' to be a list")
        pulumi.set(__self__, "plugins", plugins)
        if total_count and not isinstance(total_count, int):
            raise TypeError("Expected argument 'total_count' to be a int")
        pulumi.set(__self__, "total_count", total_count)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="nameRegex")
    def name_regex(self) -> Optional[str]:
        return pulumi.get(self, "name_regex")

    @property
    @pulumi.getter(name="outputFile")
    def output_file(self) -> Optional[str]:
        return pulumi.get(self, "output_file")

    @property
    @pulumi.getter
    def plugins(self) -> Sequence['outputs.GetInstancePluginsPluginResult']:
        """
        The collection of query.
        """
        return pulumi.get(self, "plugins")

    @property
    @pulumi.getter(name="totalCount")
    def total_count(self) -> int:
        """
        The total count of query.
        """
        return pulumi.get(self, "total_count")


class AwaitableGetInstancePluginsResult(GetInstancePluginsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetInstancePluginsResult(
            id=self.id,
            instance_id=self.instance_id,
            name_regex=self.name_regex,
            output_file=self.output_file,
            plugins=self.plugins,
            total_count=self.total_count)


def get_instance_plugins(instance_id: Optional[str] = None,
                         name_regex: Optional[str] = None,
                         output_file: Optional[str] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetInstancePluginsResult:
    """
    Use this data source to query detailed information of rabbitmq instance plugins
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo_zones = volcengine.ecs.get_zones()
    foo_vpc = volcengine.vpc.Vpc("fooVpc",
        vpc_name="acc-test-vpc",
        cidr_block="172.16.0.0/16")
    foo_subnet = volcengine.vpc.Subnet("fooSubnet",
        subnet_name="acc-test-subnet",
        cidr_block="172.16.0.0/24",
        zone_id=foo_zones.zones[0].id,
        vpc_id=foo_vpc.id)
    foo_instance = volcengine.rabbitmq.Instance("fooInstance",
        zone_ids=[
            foo_zones.zones[0].id,
            foo_zones.zones[1].id,
            foo_zones.zones[2].id,
        ],
        subnet_id=foo_subnet.id,
        version="3.8.18",
        user_name="acc-test-user",
        user_password="93f0cb0614Aab12",
        compute_spec="rabbitmq.n3.x2.small",
        storage_space=300,
        instance_name="acc-test-rabbitmq",
        instance_description="acc-test",
        charge_info=volcengine.rabbitmq.InstanceChargeInfoArgs(
            charge_type="PostPaid",
        ),
        project_name="default",
        tags=[volcengine.rabbitmq.InstanceTagArgs(
            key="k1",
            value="v1",
        )])
    foo_instance_plugins = volcengine.rabbitmq.get_instance_plugins_output(instance_id=foo_instance.id)
    ```


    :param str instance_id: The id of rabbitmq instance.
    :param str name_regex: A Name Regex of Resource.
    :param str output_file: File name where to save data source results.
    """
    __args__ = dict()
    __args__['instanceId'] = instance_id
    __args__['nameRegex'] = name_regex
    __args__['outputFile'] = output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('volcengine:rabbitmq/getInstancePlugins:getInstancePlugins', __args__, opts=opts, typ=GetInstancePluginsResult).value

    return AwaitableGetInstancePluginsResult(
        id=pulumi.get(__ret__, 'id'),
        instance_id=pulumi.get(__ret__, 'instance_id'),
        name_regex=pulumi.get(__ret__, 'name_regex'),
        output_file=pulumi.get(__ret__, 'output_file'),
        plugins=pulumi.get(__ret__, 'plugins'),
        total_count=pulumi.get(__ret__, 'total_count'))


@_utilities.lift_output_func(get_instance_plugins)
def get_instance_plugins_output(instance_id: Optional[pulumi.Input[str]] = None,
                                name_regex: Optional[pulumi.Input[Optional[str]]] = None,
                                output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetInstancePluginsResult]:
    """
    Use this data source to query detailed information of rabbitmq instance plugins
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo_zones = volcengine.ecs.get_zones()
    foo_vpc = volcengine.vpc.Vpc("fooVpc",
        vpc_name="acc-test-vpc",
        cidr_block="172.16.0.0/16")
    foo_subnet = volcengine.vpc.Subnet("fooSubnet",
        subnet_name="acc-test-subnet",
        cidr_block="172.16.0.0/24",
        zone_id=foo_zones.zones[0].id,
        vpc_id=foo_vpc.id)
    foo_instance = volcengine.rabbitmq.Instance("fooInstance",
        zone_ids=[
            foo_zones.zones[0].id,
            foo_zones.zones[1].id,
            foo_zones.zones[2].id,
        ],
        subnet_id=foo_subnet.id,
        version="3.8.18",
        user_name="acc-test-user",
        user_password="93f0cb0614Aab12",
        compute_spec="rabbitmq.n3.x2.small",
        storage_space=300,
        instance_name="acc-test-rabbitmq",
        instance_description="acc-test",
        charge_info=volcengine.rabbitmq.InstanceChargeInfoArgs(
            charge_type="PostPaid",
        ),
        project_name="default",
        tags=[volcengine.rabbitmq.InstanceTagArgs(
            key="k1",
            value="v1",
        )])
    foo_instance_plugins = volcengine.rabbitmq.get_instance_plugins_output(instance_id=foo_instance.id)
    ```


    :param str instance_id: The id of rabbitmq instance.
    :param str name_regex: A Name Regex of Resource.
    :param str output_file: File name where to save data source results.
    """
    ...
