# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'ParameterTemplatesResult',
    'AwaitableParameterTemplatesResult',
    'parameter_templates',
    'parameter_templates_output',
]

warnings.warn("""volcengine.rds_mysql.ParameterTemplates has been deprecated in favor of volcengine.rds_mysql.getParameterTemplates""", DeprecationWarning)

@pulumi.output_type
class ParameterTemplatesResult:
    """
    A collection of values returned by ParameterTemplates.
    """
    def __init__(__self__, id=None, output_file=None, template_category=None, template_source=None, template_type=None, template_type_version=None, templates=None, total_count=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if output_file and not isinstance(output_file, str):
            raise TypeError("Expected argument 'output_file' to be a str")
        pulumi.set(__self__, "output_file", output_file)
        if template_category and not isinstance(template_category, str):
            raise TypeError("Expected argument 'template_category' to be a str")
        pulumi.set(__self__, "template_category", template_category)
        if template_source and not isinstance(template_source, str):
            raise TypeError("Expected argument 'template_source' to be a str")
        pulumi.set(__self__, "template_source", template_source)
        if template_type and not isinstance(template_type, str):
            raise TypeError("Expected argument 'template_type' to be a str")
        pulumi.set(__self__, "template_type", template_type)
        if template_type_version and not isinstance(template_type_version, str):
            raise TypeError("Expected argument 'template_type_version' to be a str")
        pulumi.set(__self__, "template_type_version", template_type_version)
        if templates and not isinstance(templates, list):
            raise TypeError("Expected argument 'templates' to be a list")
        pulumi.set(__self__, "templates", templates)
        if total_count and not isinstance(total_count, int):
            raise TypeError("Expected argument 'total_count' to be a int")
        pulumi.set(__self__, "total_count", total_count)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="outputFile")
    def output_file(self) -> Optional[str]:
        return pulumi.get(self, "output_file")

    @property
    @pulumi.getter(name="templateCategory")
    def template_category(self) -> Optional[str]:
        """
        Template category, with a value of DBEngine (database engine parameter).
        """
        return pulumi.get(self, "template_category")

    @property
    @pulumi.getter(name="templateSource")
    def template_source(self) -> Optional[str]:
        """
        The type of parameter template. Values:
        System: System template.
        User: User template.
        """
        return pulumi.get(self, "template_source")

    @property
    @pulumi.getter(name="templateType")
    def template_type(self) -> Optional[str]:
        """
        The database type of the parameter template. The default value is Mysql.
        """
        return pulumi.get(self, "template_type")

    @property
    @pulumi.getter(name="templateTypeVersion")
    def template_type_version(self) -> Optional[str]:
        """
        Parameter template database version, value range:
        "MySQL_5_7": MySQL 5.7 version.
        "MySQL_8_0": MySQL 8.0 version.
        """
        return pulumi.get(self, "template_type_version")

    @property
    @pulumi.getter
    def templates(self) -> Sequence['outputs.ParameterTemplatesTemplateResult']:
        """
        The collection of query.
        """
        return pulumi.get(self, "templates")

    @property
    @pulumi.getter(name="totalCount")
    def total_count(self) -> int:
        """
        The total count of query.
        """
        return pulumi.get(self, "total_count")


class AwaitableParameterTemplatesResult(ParameterTemplatesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ParameterTemplatesResult(
            id=self.id,
            output_file=self.output_file,
            template_category=self.template_category,
            template_source=self.template_source,
            template_type=self.template_type,
            template_type_version=self.template_type_version,
            templates=self.templates,
            total_count=self.total_count)


def parameter_templates(output_file: Optional[str] = None,
                        template_category: Optional[str] = None,
                        template_source: Optional[str] = None,
                        template_type: Optional[str] = None,
                        template_type_version: Optional[str] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableParameterTemplatesResult:
    """
    Use this data source to query detailed information of rds mysql parameter templates
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo = volcengine.rds_mysql.get_parameter_templates(template_category="DBEngine",
        template_source="User")
    ```


    :param str output_file: File name where to save data source results.
    :param str template_category: Template category, with a value of DBEngine (database engine parameters).
    :param str template_source: Parameter template source, value range: System. User.
    :param str template_type: Database type of parameter template. The default value is Mysql.
    :param str template_type_version: Database version of parameter template. Value range:
           MySQL_5_7: Default value. MySQL 5.7 version.
           MySQL_8_0: MySQL 8.0 version.
    """
    pulumi.log.warn("""parameter_templates is deprecated: volcengine.rds_mysql.ParameterTemplates has been deprecated in favor of volcengine.rds_mysql.getParameterTemplates""")
    __args__ = dict()
    __args__['outputFile'] = output_file
    __args__['templateCategory'] = template_category
    __args__['templateSource'] = template_source
    __args__['templateType'] = template_type
    __args__['templateTypeVersion'] = template_type_version
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('volcengine:rds_mysql/parameterTemplates:ParameterTemplates', __args__, opts=opts, typ=ParameterTemplatesResult).value

    return AwaitableParameterTemplatesResult(
        id=pulumi.get(__ret__, 'id'),
        output_file=pulumi.get(__ret__, 'output_file'),
        template_category=pulumi.get(__ret__, 'template_category'),
        template_source=pulumi.get(__ret__, 'template_source'),
        template_type=pulumi.get(__ret__, 'template_type'),
        template_type_version=pulumi.get(__ret__, 'template_type_version'),
        templates=pulumi.get(__ret__, 'templates'),
        total_count=pulumi.get(__ret__, 'total_count'))


@_utilities.lift_output_func(parameter_templates)
def parameter_templates_output(output_file: Optional[pulumi.Input[Optional[str]]] = None,
                               template_category: Optional[pulumi.Input[Optional[str]]] = None,
                               template_source: Optional[pulumi.Input[Optional[str]]] = None,
                               template_type: Optional[pulumi.Input[Optional[str]]] = None,
                               template_type_version: Optional[pulumi.Input[Optional[str]]] = None,
                               opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[ParameterTemplatesResult]:
    """
    Use this data source to query detailed information of rds mysql parameter templates
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo = volcengine.rds_mysql.get_parameter_templates(template_category="DBEngine",
        template_source="User")
    ```


    :param str output_file: File name where to save data source results.
    :param str template_category: Template category, with a value of DBEngine (database engine parameters).
    :param str template_source: Parameter template source, value range: System. User.
    :param str template_type: Database type of parameter template. The default value is Mysql.
    :param str template_type_version: Database version of parameter template. Value range:
           MySQL_5_7: Default value. MySQL 5.7 version.
           MySQL_8_0: MySQL 8.0 version.
    """
    pulumi.log.warn("""parameter_templates is deprecated: volcengine.rds_mysql.ParameterTemplates has been deprecated in favor of volcengine.rds_mysql.getParameterTemplates""")
    ...
