# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetAllowListsResult',
    'AwaitableGetAllowListsResult',
    'get_allow_lists',
    'get_allow_lists_output',
]

@pulumi.output_type
class GetAllowListsResult:
    """
    A collection of values returned by getAllowLists.
    """
    def __init__(__self__, id=None, output_file=None, rocketmq_allow_lists=None, total_count=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if output_file and not isinstance(output_file, str):
            raise TypeError("Expected argument 'output_file' to be a str")
        pulumi.set(__self__, "output_file", output_file)
        if rocketmq_allow_lists and not isinstance(rocketmq_allow_lists, list):
            raise TypeError("Expected argument 'rocketmq_allow_lists' to be a list")
        pulumi.set(__self__, "rocketmq_allow_lists", rocketmq_allow_lists)
        if total_count and not isinstance(total_count, int):
            raise TypeError("Expected argument 'total_count' to be a int")
        pulumi.set(__self__, "total_count", total_count)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="outputFile")
    def output_file(self) -> Optional[str]:
        return pulumi.get(self, "output_file")

    @property
    @pulumi.getter(name="rocketmqAllowLists")
    def rocketmq_allow_lists(self) -> Sequence['outputs.GetAllowListsRocketmqAllowListResult']:
        """
        The collection of query.
        """
        return pulumi.get(self, "rocketmq_allow_lists")

    @property
    @pulumi.getter(name="totalCount")
    def total_count(self) -> int:
        """
        The total count of query.
        """
        return pulumi.get(self, "total_count")


class AwaitableGetAllowListsResult(GetAllowListsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAllowListsResult(
            id=self.id,
            output_file=self.output_file,
            rocketmq_allow_lists=self.rocketmq_allow_lists,
            total_count=self.total_count)


def get_allow_lists(output_file: Optional[str] = None,
                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAllowListsResult:
    """
    Use this data source to query detailed information of rocketmq allow lists
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo = volcengine.rocketmq.get_allow_lists()
    ```


    :param str output_file: File name where to save data source results.
    """
    __args__ = dict()
    __args__['outputFile'] = output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('volcengine:rocketmq/getAllowLists:getAllowLists', __args__, opts=opts, typ=GetAllowListsResult).value

    return AwaitableGetAllowListsResult(
        id=pulumi.get(__ret__, 'id'),
        output_file=pulumi.get(__ret__, 'output_file'),
        rocketmq_allow_lists=pulumi.get(__ret__, 'rocketmq_allow_lists'),
        total_count=pulumi.get(__ret__, 'total_count'))


@_utilities.lift_output_func(get_allow_lists)
def get_allow_lists_output(output_file: Optional[pulumi.Input[Optional[str]]] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetAllowListsResult]:
    """
    Use this data source to query detailed information of rocketmq allow lists
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo = volcengine.rocketmq.get_allow_lists()
    ```


    :param str output_file: File name where to save data source results.
    """
    ...
