# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['RocketMQAllowListArgs', 'RocketMQAllowList']

@pulumi.input_type
class RocketMQAllowListArgs:
    def __init__(__self__, *,
                 allow_list_name: pulumi.Input[str],
                 allow_lists: pulumi.Input[Sequence[pulumi.Input[str]]],
                 allow_list_desc: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a RocketMQAllowList resource.
        :param pulumi.Input[str] allow_list_name: The name of the allow list.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] allow_lists: The list of ip addresses. Enter an IP address or a range of IP addresses in CIDR format.
        :param pulumi.Input[str] allow_list_desc: The description of the allow list.
        """
        pulumi.set(__self__, "allow_list_name", allow_list_name)
        pulumi.set(__self__, "allow_lists", allow_lists)
        if allow_list_desc is not None:
            pulumi.set(__self__, "allow_list_desc", allow_list_desc)

    @property
    @pulumi.getter(name="allowListName")
    def allow_list_name(self) -> pulumi.Input[str]:
        """
        The name of the allow list.
        """
        return pulumi.get(self, "allow_list_name")

    @allow_list_name.setter
    def allow_list_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "allow_list_name", value)

    @property
    @pulumi.getter(name="allowLists")
    def allow_lists(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        The list of ip addresses. Enter an IP address or a range of IP addresses in CIDR format.
        """
        return pulumi.get(self, "allow_lists")

    @allow_lists.setter
    def allow_lists(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "allow_lists", value)

    @property
    @pulumi.getter(name="allowListDesc")
    def allow_list_desc(self) -> Optional[pulumi.Input[str]]:
        """
        The description of the allow list.
        """
        return pulumi.get(self, "allow_list_desc")

    @allow_list_desc.setter
    def allow_list_desc(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "allow_list_desc", value)


@pulumi.input_type
class _RocketMQAllowListState:
    def __init__(__self__, *,
                 allow_list_desc: Optional[pulumi.Input[str]] = None,
                 allow_list_ip_num: Optional[pulumi.Input[int]] = None,
                 allow_list_name: Optional[pulumi.Input[str]] = None,
                 allow_list_type: Optional[pulumi.Input[str]] = None,
                 allow_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 associated_instance_num: Optional[pulumi.Input[int]] = None,
                 associated_instances: Optional[pulumi.Input[Sequence[pulumi.Input['RocketMQAllowListAssociatedInstanceArgs']]]] = None):
        """
        Input properties used for looking up and filtering RocketMQAllowList resources.
        :param pulumi.Input[str] allow_list_desc: The description of the allow list.
        :param pulumi.Input[int] allow_list_ip_num: The number of ip address in the rocketmq allow list.
        :param pulumi.Input[str] allow_list_name: The name of the allow list.
        :param pulumi.Input[str] allow_list_type: The type of the rocketmq allow list.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] allow_lists: The list of ip addresses. Enter an IP address or a range of IP addresses in CIDR format.
        :param pulumi.Input[int] associated_instance_num: The number of the rocketmq instances associated with the allow list.
        :param pulumi.Input[Sequence[pulumi.Input['RocketMQAllowListAssociatedInstanceArgs']]] associated_instances: The associated instance information of the allow list.
        """
        if allow_list_desc is not None:
            pulumi.set(__self__, "allow_list_desc", allow_list_desc)
        if allow_list_ip_num is not None:
            pulumi.set(__self__, "allow_list_ip_num", allow_list_ip_num)
        if allow_list_name is not None:
            pulumi.set(__self__, "allow_list_name", allow_list_name)
        if allow_list_type is not None:
            pulumi.set(__self__, "allow_list_type", allow_list_type)
        if allow_lists is not None:
            pulumi.set(__self__, "allow_lists", allow_lists)
        if associated_instance_num is not None:
            pulumi.set(__self__, "associated_instance_num", associated_instance_num)
        if associated_instances is not None:
            pulumi.set(__self__, "associated_instances", associated_instances)

    @property
    @pulumi.getter(name="allowListDesc")
    def allow_list_desc(self) -> Optional[pulumi.Input[str]]:
        """
        The description of the allow list.
        """
        return pulumi.get(self, "allow_list_desc")

    @allow_list_desc.setter
    def allow_list_desc(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "allow_list_desc", value)

    @property
    @pulumi.getter(name="allowListIpNum")
    def allow_list_ip_num(self) -> Optional[pulumi.Input[int]]:
        """
        The number of ip address in the rocketmq allow list.
        """
        return pulumi.get(self, "allow_list_ip_num")

    @allow_list_ip_num.setter
    def allow_list_ip_num(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "allow_list_ip_num", value)

    @property
    @pulumi.getter(name="allowListName")
    def allow_list_name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the allow list.
        """
        return pulumi.get(self, "allow_list_name")

    @allow_list_name.setter
    def allow_list_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "allow_list_name", value)

    @property
    @pulumi.getter(name="allowListType")
    def allow_list_type(self) -> Optional[pulumi.Input[str]]:
        """
        The type of the rocketmq allow list.
        """
        return pulumi.get(self, "allow_list_type")

    @allow_list_type.setter
    def allow_list_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "allow_list_type", value)

    @property
    @pulumi.getter(name="allowLists")
    def allow_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The list of ip addresses. Enter an IP address or a range of IP addresses in CIDR format.
        """
        return pulumi.get(self, "allow_lists")

    @allow_lists.setter
    def allow_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "allow_lists", value)

    @property
    @pulumi.getter(name="associatedInstanceNum")
    def associated_instance_num(self) -> Optional[pulumi.Input[int]]:
        """
        The number of the rocketmq instances associated with the allow list.
        """
        return pulumi.get(self, "associated_instance_num")

    @associated_instance_num.setter
    def associated_instance_num(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "associated_instance_num", value)

    @property
    @pulumi.getter(name="associatedInstances")
    def associated_instances(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['RocketMQAllowListAssociatedInstanceArgs']]]]:
        """
        The associated instance information of the allow list.
        """
        return pulumi.get(self, "associated_instances")

    @associated_instances.setter
    def associated_instances(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['RocketMQAllowListAssociatedInstanceArgs']]]]):
        pulumi.set(self, "associated_instances", value)


class RocketMQAllowList(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 allow_list_desc: Optional[pulumi.Input[str]] = None,
                 allow_list_name: Optional[pulumi.Input[str]] = None,
                 allow_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 __props__=None):
        """
        Provides a resource to manage rocketmq allow list
        ## Example Usage

        ```python
        import pulumi
        import pulumi_volcengine as volcengine

        foo = volcengine.rocketmq.RocketMQAllowList("foo",
            allow_lists=[
                "192.168.0.0/24",
                "192.168.2.0/24",
            ],
            allow_list_desc="acc-test",
            allow_list_name="acc-test-allow-list")
        ```

        ## Import

        RocketmqAllowList can be imported using the id, e.g.

        ```sh
        $ pulumi import volcengine:rocketmq/rocketMQAllowList:RocketMQAllowList default resource_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] allow_list_desc: The description of the allow list.
        :param pulumi.Input[str] allow_list_name: The name of the allow list.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] allow_lists: The list of ip addresses. Enter an IP address or a range of IP addresses in CIDR format.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: RocketMQAllowListArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to manage rocketmq allow list
        ## Example Usage

        ```python
        import pulumi
        import pulumi_volcengine as volcengine

        foo = volcengine.rocketmq.RocketMQAllowList("foo",
            allow_lists=[
                "192.168.0.0/24",
                "192.168.2.0/24",
            ],
            allow_list_desc="acc-test",
            allow_list_name="acc-test-allow-list")
        ```

        ## Import

        RocketmqAllowList can be imported using the id, e.g.

        ```sh
        $ pulumi import volcengine:rocketmq/rocketMQAllowList:RocketMQAllowList default resource_id
        ```

        :param str resource_name: The name of the resource.
        :param RocketMQAllowListArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(RocketMQAllowListArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 allow_list_desc: Optional[pulumi.Input[str]] = None,
                 allow_list_name: Optional[pulumi.Input[str]] = None,
                 allow_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = RocketMQAllowListArgs.__new__(RocketMQAllowListArgs)

            __props__.__dict__["allow_list_desc"] = allow_list_desc
            if allow_list_name is None and not opts.urn:
                raise TypeError("Missing required property 'allow_list_name'")
            __props__.__dict__["allow_list_name"] = allow_list_name
            if allow_lists is None and not opts.urn:
                raise TypeError("Missing required property 'allow_lists'")
            __props__.__dict__["allow_lists"] = allow_lists
            __props__.__dict__["allow_list_ip_num"] = None
            __props__.__dict__["allow_list_type"] = None
            __props__.__dict__["associated_instance_num"] = None
            __props__.__dict__["associated_instances"] = None
        super(RocketMQAllowList, __self__).__init__(
            'volcengine:rocketmq/rocketMQAllowList:RocketMQAllowList',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            allow_list_desc: Optional[pulumi.Input[str]] = None,
            allow_list_ip_num: Optional[pulumi.Input[int]] = None,
            allow_list_name: Optional[pulumi.Input[str]] = None,
            allow_list_type: Optional[pulumi.Input[str]] = None,
            allow_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            associated_instance_num: Optional[pulumi.Input[int]] = None,
            associated_instances: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['RocketMQAllowListAssociatedInstanceArgs']]]]] = None) -> 'RocketMQAllowList':
        """
        Get an existing RocketMQAllowList resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] allow_list_desc: The description of the allow list.
        :param pulumi.Input[int] allow_list_ip_num: The number of ip address in the rocketmq allow list.
        :param pulumi.Input[str] allow_list_name: The name of the allow list.
        :param pulumi.Input[str] allow_list_type: The type of the rocketmq allow list.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] allow_lists: The list of ip addresses. Enter an IP address or a range of IP addresses in CIDR format.
        :param pulumi.Input[int] associated_instance_num: The number of the rocketmq instances associated with the allow list.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['RocketMQAllowListAssociatedInstanceArgs']]]] associated_instances: The associated instance information of the allow list.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _RocketMQAllowListState.__new__(_RocketMQAllowListState)

        __props__.__dict__["allow_list_desc"] = allow_list_desc
        __props__.__dict__["allow_list_ip_num"] = allow_list_ip_num
        __props__.__dict__["allow_list_name"] = allow_list_name
        __props__.__dict__["allow_list_type"] = allow_list_type
        __props__.__dict__["allow_lists"] = allow_lists
        __props__.__dict__["associated_instance_num"] = associated_instance_num
        __props__.__dict__["associated_instances"] = associated_instances
        return RocketMQAllowList(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="allowListDesc")
    def allow_list_desc(self) -> pulumi.Output[Optional[str]]:
        """
        The description of the allow list.
        """
        return pulumi.get(self, "allow_list_desc")

    @property
    @pulumi.getter(name="allowListIpNum")
    def allow_list_ip_num(self) -> pulumi.Output[int]:
        """
        The number of ip address in the rocketmq allow list.
        """
        return pulumi.get(self, "allow_list_ip_num")

    @property
    @pulumi.getter(name="allowListName")
    def allow_list_name(self) -> pulumi.Output[str]:
        """
        The name of the allow list.
        """
        return pulumi.get(self, "allow_list_name")

    @property
    @pulumi.getter(name="allowListType")
    def allow_list_type(self) -> pulumi.Output[str]:
        """
        The type of the rocketmq allow list.
        """
        return pulumi.get(self, "allow_list_type")

    @property
    @pulumi.getter(name="allowLists")
    def allow_lists(self) -> pulumi.Output[Sequence[str]]:
        """
        The list of ip addresses. Enter an IP address or a range of IP addresses in CIDR format.
        """
        return pulumi.get(self, "allow_lists")

    @property
    @pulumi.getter(name="associatedInstanceNum")
    def associated_instance_num(self) -> pulumi.Output[int]:
        """
        The number of the rocketmq instances associated with the allow list.
        """
        return pulumi.get(self, "associated_instance_num")

    @property
    @pulumi.getter(name="associatedInstances")
    def associated_instances(self) -> pulumi.Output[Sequence['outputs.RocketMQAllowListAssociatedInstance']]:
        """
        The associated instance information of the allow list.
        """
        return pulumi.get(self, "associated_instances")

