# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['BatchEdgeMachineArgs', 'BatchEdgeMachine']

@pulumi.input_type
class BatchEdgeMachineArgs:
    def __init__(__self__, *,
                 cluster_id: pulumi.Input[str],
                 node_pool_id: pulumi.Input[str],
                 ttl_hours: pulumi.Input[int],
                 client_token: Optional[pulumi.Input[str]] = None,
                 expiration_date: Optional[pulumi.Input[int]] = None,
                 name: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a BatchEdgeMachine resource.
        :param pulumi.Input[str] cluster_id: The cluster id.
        :param pulumi.Input[str] node_pool_id: The node pool id.
        :param pulumi.Input[int] ttl_hours: Effective hours of the managed script are counted from the creation time.
        :param pulumi.Input[str] client_token: The client token.
        :param pulumi.Input[int] expiration_date: Expiration date of the managed script, UTC time point, in seconds. If the expiration time is set, TTLHours will be ignored.
        :param pulumi.Input[str] name: The name of the node.
        """
        pulumi.set(__self__, "cluster_id", cluster_id)
        pulumi.set(__self__, "node_pool_id", node_pool_id)
        pulumi.set(__self__, "ttl_hours", ttl_hours)
        if client_token is not None:
            pulumi.set(__self__, "client_token", client_token)
        if expiration_date is not None:
            pulumi.set(__self__, "expiration_date", expiration_date)
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter(name="clusterId")
    def cluster_id(self) -> pulumi.Input[str]:
        """
        The cluster id.
        """
        return pulumi.get(self, "cluster_id")

    @cluster_id.setter
    def cluster_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "cluster_id", value)

    @property
    @pulumi.getter(name="nodePoolId")
    def node_pool_id(self) -> pulumi.Input[str]:
        """
        The node pool id.
        """
        return pulumi.get(self, "node_pool_id")

    @node_pool_id.setter
    def node_pool_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "node_pool_id", value)

    @property
    @pulumi.getter(name="ttlHours")
    def ttl_hours(self) -> pulumi.Input[int]:
        """
        Effective hours of the managed script are counted from the creation time.
        """
        return pulumi.get(self, "ttl_hours")

    @ttl_hours.setter
    def ttl_hours(self, value: pulumi.Input[int]):
        pulumi.set(self, "ttl_hours", value)

    @property
    @pulumi.getter(name="clientToken")
    def client_token(self) -> Optional[pulumi.Input[str]]:
        """
        The client token.
        """
        return pulumi.get(self, "client_token")

    @client_token.setter
    def client_token(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "client_token", value)

    @property
    @pulumi.getter(name="expirationDate")
    def expiration_date(self) -> Optional[pulumi.Input[int]]:
        """
        Expiration date of the managed script, UTC time point, in seconds. If the expiration time is set, TTLHours will be ignored.
        """
        return pulumi.get(self, "expiration_date")

    @expiration_date.setter
    def expiration_date(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "expiration_date", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the node.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)


@pulumi.input_type
class _BatchEdgeMachineState:
    def __init__(__self__, *,
                 client_token: Optional[pulumi.Input[str]] = None,
                 cluster_id: Optional[pulumi.Input[str]] = None,
                 expiration_date: Optional[pulumi.Input[int]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 node_pool_id: Optional[pulumi.Input[str]] = None,
                 ttl_hours: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering BatchEdgeMachine resources.
        :param pulumi.Input[str] client_token: The client token.
        :param pulumi.Input[str] cluster_id: The cluster id.
        :param pulumi.Input[int] expiration_date: Expiration date of the managed script, UTC time point, in seconds. If the expiration time is set, TTLHours will be ignored.
        :param pulumi.Input[str] name: The name of the node.
        :param pulumi.Input[str] node_pool_id: The node pool id.
        :param pulumi.Input[int] ttl_hours: Effective hours of the managed script are counted from the creation time.
        """
        if client_token is not None:
            pulumi.set(__self__, "client_token", client_token)
        if cluster_id is not None:
            pulumi.set(__self__, "cluster_id", cluster_id)
        if expiration_date is not None:
            pulumi.set(__self__, "expiration_date", expiration_date)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if node_pool_id is not None:
            pulumi.set(__self__, "node_pool_id", node_pool_id)
        if ttl_hours is not None:
            pulumi.set(__self__, "ttl_hours", ttl_hours)

    @property
    @pulumi.getter(name="clientToken")
    def client_token(self) -> Optional[pulumi.Input[str]]:
        """
        The client token.
        """
        return pulumi.get(self, "client_token")

    @client_token.setter
    def client_token(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "client_token", value)

    @property
    @pulumi.getter(name="clusterId")
    def cluster_id(self) -> Optional[pulumi.Input[str]]:
        """
        The cluster id.
        """
        return pulumi.get(self, "cluster_id")

    @cluster_id.setter
    def cluster_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cluster_id", value)

    @property
    @pulumi.getter(name="expirationDate")
    def expiration_date(self) -> Optional[pulumi.Input[int]]:
        """
        Expiration date of the managed script, UTC time point, in seconds. If the expiration time is set, TTLHours will be ignored.
        """
        return pulumi.get(self, "expiration_date")

    @expiration_date.setter
    def expiration_date(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "expiration_date", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the node.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="nodePoolId")
    def node_pool_id(self) -> Optional[pulumi.Input[str]]:
        """
        The node pool id.
        """
        return pulumi.get(self, "node_pool_id")

    @node_pool_id.setter
    def node_pool_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "node_pool_id", value)

    @property
    @pulumi.getter(name="ttlHours")
    def ttl_hours(self) -> Optional[pulumi.Input[int]]:
        """
        Effective hours of the managed script are counted from the creation time.
        """
        return pulumi.get(self, "ttl_hours")

    @ttl_hours.setter
    def ttl_hours(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "ttl_hours", value)


class BatchEdgeMachine(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 client_token: Optional[pulumi.Input[str]] = None,
                 cluster_id: Optional[pulumi.Input[str]] = None,
                 expiration_date: Optional[pulumi.Input[int]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 node_pool_id: Optional[pulumi.Input[str]] = None,
                 ttl_hours: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        Provides a resource to manage veecp batch edge machine
        ## Example Usage

        ```python
        import pulumi
        import pulumi_volcengine as volcengine

        foo = volcengine.veecp.BatchEdgeMachine("foo",
            cluster_id="ccvmb0c66t101fnob3dhg",
            node_pool_id="pcvn3alfic26jjcjsa1r0",
            ttl_hours=1)
        ```

        ## Import

        VeecpBatchEdgeMachine can be imported using the id, e.g.

        ```sh
        $ pulumi import volcengine:veecp/batchEdgeMachine:BatchEdgeMachine default resource_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] client_token: The client token.
        :param pulumi.Input[str] cluster_id: The cluster id.
        :param pulumi.Input[int] expiration_date: Expiration date of the managed script, UTC time point, in seconds. If the expiration time is set, TTLHours will be ignored.
        :param pulumi.Input[str] name: The name of the node.
        :param pulumi.Input[str] node_pool_id: The node pool id.
        :param pulumi.Input[int] ttl_hours: Effective hours of the managed script are counted from the creation time.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: BatchEdgeMachineArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to manage veecp batch edge machine
        ## Example Usage

        ```python
        import pulumi
        import pulumi_volcengine as volcengine

        foo = volcengine.veecp.BatchEdgeMachine("foo",
            cluster_id="ccvmb0c66t101fnob3dhg",
            node_pool_id="pcvn3alfic26jjcjsa1r0",
            ttl_hours=1)
        ```

        ## Import

        VeecpBatchEdgeMachine can be imported using the id, e.g.

        ```sh
        $ pulumi import volcengine:veecp/batchEdgeMachine:BatchEdgeMachine default resource_id
        ```

        :param str resource_name: The name of the resource.
        :param BatchEdgeMachineArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(BatchEdgeMachineArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 client_token: Optional[pulumi.Input[str]] = None,
                 cluster_id: Optional[pulumi.Input[str]] = None,
                 expiration_date: Optional[pulumi.Input[int]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 node_pool_id: Optional[pulumi.Input[str]] = None,
                 ttl_hours: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = BatchEdgeMachineArgs.__new__(BatchEdgeMachineArgs)

            __props__.__dict__["client_token"] = client_token
            if cluster_id is None and not opts.urn:
                raise TypeError("Missing required property 'cluster_id'")
            __props__.__dict__["cluster_id"] = cluster_id
            __props__.__dict__["expiration_date"] = expiration_date
            __props__.__dict__["name"] = name
            if node_pool_id is None and not opts.urn:
                raise TypeError("Missing required property 'node_pool_id'")
            __props__.__dict__["node_pool_id"] = node_pool_id
            if ttl_hours is None and not opts.urn:
                raise TypeError("Missing required property 'ttl_hours'")
            __props__.__dict__["ttl_hours"] = ttl_hours
        super(BatchEdgeMachine, __self__).__init__(
            'volcengine:veecp/batchEdgeMachine:BatchEdgeMachine',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            client_token: Optional[pulumi.Input[str]] = None,
            cluster_id: Optional[pulumi.Input[str]] = None,
            expiration_date: Optional[pulumi.Input[int]] = None,
            name: Optional[pulumi.Input[str]] = None,
            node_pool_id: Optional[pulumi.Input[str]] = None,
            ttl_hours: Optional[pulumi.Input[int]] = None) -> 'BatchEdgeMachine':
        """
        Get an existing BatchEdgeMachine resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] client_token: The client token.
        :param pulumi.Input[str] cluster_id: The cluster id.
        :param pulumi.Input[int] expiration_date: Expiration date of the managed script, UTC time point, in seconds. If the expiration time is set, TTLHours will be ignored.
        :param pulumi.Input[str] name: The name of the node.
        :param pulumi.Input[str] node_pool_id: The node pool id.
        :param pulumi.Input[int] ttl_hours: Effective hours of the managed script are counted from the creation time.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _BatchEdgeMachineState.__new__(_BatchEdgeMachineState)

        __props__.__dict__["client_token"] = client_token
        __props__.__dict__["cluster_id"] = cluster_id
        __props__.__dict__["expiration_date"] = expiration_date
        __props__.__dict__["name"] = name
        __props__.__dict__["node_pool_id"] = node_pool_id
        __props__.__dict__["ttl_hours"] = ttl_hours
        return BatchEdgeMachine(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="clientToken")
    def client_token(self) -> pulumi.Output[Optional[str]]:
        """
        The client token.
        """
        return pulumi.get(self, "client_token")

    @property
    @pulumi.getter(name="clusterId")
    def cluster_id(self) -> pulumi.Output[str]:
        """
        The cluster id.
        """
        return pulumi.get(self, "cluster_id")

    @property
    @pulumi.getter(name="expirationDate")
    def expiration_date(self) -> pulumi.Output[int]:
        """
        Expiration date of the managed script, UTC time point, in seconds. If the expiration time is set, TTLHours will be ignored.
        """
        return pulumi.get(self, "expiration_date")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the node.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="nodePoolId")
    def node_pool_id(self) -> pulumi.Output[str]:
        """
        The node pool id.
        """
        return pulumi.get(self, "node_pool_id")

    @property
    @pulumi.getter(name="ttlHours")
    def ttl_hours(self) -> pulumi.Output[int]:
        """
        Effective hours of the managed script are counted from the creation time.
        """
        return pulumi.get(self, "ttl_hours")

