# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['ContactGroupArgs', 'ContactGroup']

@pulumi.input_type
class ContactGroupArgs:
    def __init__(__self__, *,
                 contact_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a ContactGroup resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] contact_ids: A list of contact IDs.
        :param pulumi.Input[str] name: The name of the contact group.
        """
        if contact_ids is not None:
            pulumi.set(__self__, "contact_ids", contact_ids)
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter(name="contactIds")
    def contact_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        A list of contact IDs.
        """
        return pulumi.get(self, "contact_ids")

    @contact_ids.setter
    def contact_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "contact_ids", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the contact group.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)


@pulumi.input_type
class _ContactGroupState:
    def __init__(__self__, *,
                 contact_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 create_time: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering ContactGroup resources.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] contact_ids: A list of contact IDs.
        :param pulumi.Input[str] create_time: The create time of contact group.
        :param pulumi.Input[str] name: The name of the contact group.
        """
        if contact_ids is not None:
            pulumi.set(__self__, "contact_ids", contact_ids)
        if create_time is not None:
            pulumi.set(__self__, "create_time", create_time)
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter(name="contactIds")
    def contact_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        A list of contact IDs.
        """
        return pulumi.get(self, "contact_ids")

    @contact_ids.setter
    def contact_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "contact_ids", value)

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> Optional[pulumi.Input[str]]:
        """
        The create time of contact group.
        """
        return pulumi.get(self, "create_time")

    @create_time.setter
    def create_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "create_time", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the contact group.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)


class ContactGroup(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 contact_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to manage vmp contact group
        ## Example Usage

        ```python
        import pulumi
        import pulumi_volcengine as volcengine

        foo_contact = volcengine.vmp.Contact("fooContact",
            email="acctest1@tftest.com",
            webhook=volcengine.vmp.ContactWebhookArgs(
                address="https://www.acctest1.com",
            ),
            lark_bot_webhook=volcengine.vmp.ContactLarkBotWebhookArgs(
                address="https://www.acctest1.com",
            ),
            ding_talk_bot_webhook=volcengine.vmp.ContactDingTalkBotWebhookArgs(
                address="https://www.dingacctest1.com",
                at_mobiles=["18046891812"],
            ),
            phone_number=volcengine.vmp.ContactPhoneNumberArgs(
                country_code="+86",
                number="18310101010",
            ))
        foo1 = volcengine.vmp.Contact("foo1",
            email="acctest2@tftest.com",
            webhook=volcengine.vmp.ContactWebhookArgs(
                address="https://www.acctest2.com",
            ),
            lark_bot_webhook=volcengine.vmp.ContactLarkBotWebhookArgs(
                address="https://www.acctest2.com",
            ),
            ding_talk_bot_webhook=volcengine.vmp.ContactDingTalkBotWebhookArgs(
                address="https://www.dingacctest2.com",
                at_mobiles=["18046891813"],
            ),
            phone_number=volcengine.vmp.ContactPhoneNumberArgs(
                country_code="+86",
                number="18310101011",
            ))
        foo_contact_group = volcengine.vmp.ContactGroup("fooContactGroup", contact_ids=[
            foo_contact.id,
            foo1.id,
        ])
        ```

        ## Import

        VMP Contact Group can be imported using the id, e.g.

        ```sh
        $ pulumi import volcengine:vmp/contactGroup:ContactGroup default 60dde3ca-951c-4c05-8777-e5a7caa07ad6
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] contact_ids: A list of contact IDs.
        :param pulumi.Input[str] name: The name of the contact group.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[ContactGroupArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to manage vmp contact group
        ## Example Usage

        ```python
        import pulumi
        import pulumi_volcengine as volcengine

        foo_contact = volcengine.vmp.Contact("fooContact",
            email="acctest1@tftest.com",
            webhook=volcengine.vmp.ContactWebhookArgs(
                address="https://www.acctest1.com",
            ),
            lark_bot_webhook=volcengine.vmp.ContactLarkBotWebhookArgs(
                address="https://www.acctest1.com",
            ),
            ding_talk_bot_webhook=volcengine.vmp.ContactDingTalkBotWebhookArgs(
                address="https://www.dingacctest1.com",
                at_mobiles=["18046891812"],
            ),
            phone_number=volcengine.vmp.ContactPhoneNumberArgs(
                country_code="+86",
                number="18310101010",
            ))
        foo1 = volcengine.vmp.Contact("foo1",
            email="acctest2@tftest.com",
            webhook=volcengine.vmp.ContactWebhookArgs(
                address="https://www.acctest2.com",
            ),
            lark_bot_webhook=volcengine.vmp.ContactLarkBotWebhookArgs(
                address="https://www.acctest2.com",
            ),
            ding_talk_bot_webhook=volcengine.vmp.ContactDingTalkBotWebhookArgs(
                address="https://www.dingacctest2.com",
                at_mobiles=["18046891813"],
            ),
            phone_number=volcengine.vmp.ContactPhoneNumberArgs(
                country_code="+86",
                number="18310101011",
            ))
        foo_contact_group = volcengine.vmp.ContactGroup("fooContactGroup", contact_ids=[
            foo_contact.id,
            foo1.id,
        ])
        ```

        ## Import

        VMP Contact Group can be imported using the id, e.g.

        ```sh
        $ pulumi import volcengine:vmp/contactGroup:ContactGroup default 60dde3ca-951c-4c05-8777-e5a7caa07ad6
        ```

        :param str resource_name: The name of the resource.
        :param ContactGroupArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ContactGroupArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 contact_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ContactGroupArgs.__new__(ContactGroupArgs)

            __props__.__dict__["contact_ids"] = contact_ids
            __props__.__dict__["name"] = name
            __props__.__dict__["create_time"] = None
        super(ContactGroup, __self__).__init__(
            'volcengine:vmp/contactGroup:ContactGroup',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            contact_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            create_time: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None) -> 'ContactGroup':
        """
        Get an existing ContactGroup resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] contact_ids: A list of contact IDs.
        :param pulumi.Input[str] create_time: The create time of contact group.
        :param pulumi.Input[str] name: The name of the contact group.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ContactGroupState.__new__(_ContactGroupState)

        __props__.__dict__["contact_ids"] = contact_ids
        __props__.__dict__["create_time"] = create_time
        __props__.__dict__["name"] = name
        return ContactGroup(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="contactIds")
    def contact_ids(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        A list of contact IDs.
        """
        return pulumi.get(self, "contact_ids")

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> pulumi.Output[str]:
        """
        The create time of contact group.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the contact group.
        """
        return pulumi.get(self, "name")

