# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'ContactsResult',
    'AwaitableContactsResult',
    'contacts',
    'contacts_output',
]

warnings.warn("""volcengine.vmp.Contacts has been deprecated in favor of volcengine.vmp.getContacts""", DeprecationWarning)

@pulumi.output_type
class ContactsResult:
    """
    A collection of values returned by Contacts.
    """
    def __init__(__self__, contacts=None, email=None, id=None, ids=None, name=None, output_file=None, total_count=None):
        if contacts and not isinstance(contacts, list):
            raise TypeError("Expected argument 'contacts' to be a list")
        pulumi.set(__self__, "contacts", contacts)
        if email and not isinstance(email, str):
            raise TypeError("Expected argument 'email' to be a str")
        pulumi.set(__self__, "email", email)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if ids and not isinstance(ids, list):
            raise TypeError("Expected argument 'ids' to be a list")
        pulumi.set(__self__, "ids", ids)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if output_file and not isinstance(output_file, str):
            raise TypeError("Expected argument 'output_file' to be a str")
        pulumi.set(__self__, "output_file", output_file)
        if total_count and not isinstance(total_count, int):
            raise TypeError("Expected argument 'total_count' to be a int")
        pulumi.set(__self__, "total_count", total_count)

    @property
    @pulumi.getter
    def contacts(self) -> Sequence['outputs.ContactsContactResult']:
        """
        The collection of query.
        """
        return pulumi.get(self, "contacts")

    @property
    @pulumi.getter
    def email(self) -> Optional[str]:
        """
        The email of contact.
        """
        return pulumi.get(self, "email")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def ids(self) -> Optional[Sequence[str]]:
        return pulumi.get(self, "ids")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        The name of contact.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="outputFile")
    def output_file(self) -> Optional[str]:
        return pulumi.get(self, "output_file")

    @property
    @pulumi.getter(name="totalCount")
    def total_count(self) -> int:
        """
        The total count of query.
        """
        return pulumi.get(self, "total_count")


class AwaitableContactsResult(ContactsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ContactsResult(
            contacts=self.contacts,
            email=self.email,
            id=self.id,
            ids=self.ids,
            name=self.name,
            output_file=self.output_file,
            total_count=self.total_count)


def contacts(email: Optional[str] = None,
             ids: Optional[Sequence[str]] = None,
             name: Optional[str] = None,
             output_file: Optional[str] = None,
             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableContactsResult:
    """
    Use this data source to query detailed information of vmp contacts
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo_contact = volcengine.vmp.Contact("fooContact",
        email="acctest1@tftest.com",
        webhook=volcengine.vmp.ContactWebhookArgs(
            address="https://www.acctest1.com",
        ),
        lark_bot_webhook=volcengine.vmp.ContactLarkBotWebhookArgs(
            address="https://www.acctest1.com",
        ),
        ding_talk_bot_webhook=volcengine.vmp.ContactDingTalkBotWebhookArgs(
            address="https://www.dingacctest1.com",
            at_mobiles=["18046891812"],
        ),
        phone_number=volcengine.vmp.ContactPhoneNumberArgs(
            country_code="+86",
            number="18310101010",
        ))
    foo_contacts = volcengine.vmp.get_contacts_output(ids=[foo_contact.id])
    ```


    :param str email: The email of contact.
    :param Sequence[str] ids: A list of contact ids.
    :param str name: The name of contact.
    :param str output_file: File name where to save data source results.
    """
    pulumi.log.warn("""contacts is deprecated: volcengine.vmp.Contacts has been deprecated in favor of volcengine.vmp.getContacts""")
    __args__ = dict()
    __args__['email'] = email
    __args__['ids'] = ids
    __args__['name'] = name
    __args__['outputFile'] = output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('volcengine:vmp/contacts:Contacts', __args__, opts=opts, typ=ContactsResult).value

    return AwaitableContactsResult(
        contacts=pulumi.get(__ret__, 'contacts'),
        email=pulumi.get(__ret__, 'email'),
        id=pulumi.get(__ret__, 'id'),
        ids=pulumi.get(__ret__, 'ids'),
        name=pulumi.get(__ret__, 'name'),
        output_file=pulumi.get(__ret__, 'output_file'),
        total_count=pulumi.get(__ret__, 'total_count'))


@_utilities.lift_output_func(contacts)
def contacts_output(email: Optional[pulumi.Input[Optional[str]]] = None,
                    ids: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                    name: Optional[pulumi.Input[Optional[str]]] = None,
                    output_file: Optional[pulumi.Input[Optional[str]]] = None,
                    opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[ContactsResult]:
    """
    Use this data source to query detailed information of vmp contacts
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo_contact = volcengine.vmp.Contact("fooContact",
        email="acctest1@tftest.com",
        webhook=volcengine.vmp.ContactWebhookArgs(
            address="https://www.acctest1.com",
        ),
        lark_bot_webhook=volcengine.vmp.ContactLarkBotWebhookArgs(
            address="https://www.acctest1.com",
        ),
        ding_talk_bot_webhook=volcengine.vmp.ContactDingTalkBotWebhookArgs(
            address="https://www.dingacctest1.com",
            at_mobiles=["18046891812"],
        ),
        phone_number=volcengine.vmp.ContactPhoneNumberArgs(
            country_code="+86",
            number="18310101010",
        ))
    foo_contacts = volcengine.vmp.get_contacts_output(ids=[foo_contact.id])
    ```


    :param str email: The email of contact.
    :param Sequence[str] ids: A list of contact ids.
    :param str name: The name of contact.
    :param str output_file: File name where to save data source results.
    """
    pulumi.log.warn("""contacts is deprecated: volcengine.vmp.Contacts has been deprecated in favor of volcengine.vmp.getContacts""")
    ...
