# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['NotifyGroupPolicyArgs', 'NotifyGroupPolicy']

@pulumi.input_type
class NotifyGroupPolicyArgs:
    def __init__(__self__, *,
                 levels: pulumi.Input[Sequence[pulumi.Input['NotifyGroupPolicyLevelArgs']]],
                 description: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a NotifyGroupPolicy resource.
        :param pulumi.Input[Sequence[pulumi.Input['NotifyGroupPolicyLevelArgs']]] levels: The levels of the notify group policy. Levels must be registered in three (`P0`, `P1`, `P2`) aggregation strategies, and `Level` cannot be repeated.
        :param pulumi.Input[str] description: The description of the notify group policy.
        :param pulumi.Input[str] name: The name of the notify group policy.
        """
        pulumi.set(__self__, "levels", levels)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def levels(self) -> pulumi.Input[Sequence[pulumi.Input['NotifyGroupPolicyLevelArgs']]]:
        """
        The levels of the notify group policy. Levels must be registered in three (`P0`, `P1`, `P2`) aggregation strategies, and `Level` cannot be repeated.
        """
        return pulumi.get(self, "levels")

    @levels.setter
    def levels(self, value: pulumi.Input[Sequence[pulumi.Input['NotifyGroupPolicyLevelArgs']]]):
        pulumi.set(self, "levels", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        The description of the notify group policy.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the notify group policy.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)


@pulumi.input_type
class _NotifyGroupPolicyState:
    def __init__(__self__, *,
                 description: Optional[pulumi.Input[str]] = None,
                 levels: Optional[pulumi.Input[Sequence[pulumi.Input['NotifyGroupPolicyLevelArgs']]]] = None,
                 name: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering NotifyGroupPolicy resources.
        :param pulumi.Input[str] description: The description of the notify group policy.
        :param pulumi.Input[Sequence[pulumi.Input['NotifyGroupPolicyLevelArgs']]] levels: The levels of the notify group policy. Levels must be registered in three (`P0`, `P1`, `P2`) aggregation strategies, and `Level` cannot be repeated.
        :param pulumi.Input[str] name: The name of the notify group policy.
        """
        if description is not None:
            pulumi.set(__self__, "description", description)
        if levels is not None:
            pulumi.set(__self__, "levels", levels)
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        The description of the notify group policy.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def levels(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['NotifyGroupPolicyLevelArgs']]]]:
        """
        The levels of the notify group policy. Levels must be registered in three (`P0`, `P1`, `P2`) aggregation strategies, and `Level` cannot be repeated.
        """
        return pulumi.get(self, "levels")

    @levels.setter
    def levels(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['NotifyGroupPolicyLevelArgs']]]]):
        pulumi.set(self, "levels", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the notify group policy.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)


class NotifyGroupPolicy(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 levels: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['NotifyGroupPolicyLevelArgs']]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to manage vmp notify group policy
        ## Example Usage

        ```python
        import pulumi
        import pulumi_volcengine as volcengine

        foo = volcengine.vmp.NotifyGroupPolicy("foo",
            description="acc-test-1",
            levels=[
                volcengine.vmp.NotifyGroupPolicyLevelArgs(
                    group_bies=["__rule__"],
                    group_interval="30",
                    group_wait="35",
                    level="P2",
                    repeat_interval="30",
                ),
                volcengine.vmp.NotifyGroupPolicyLevelArgs(
                    group_bies=["__rule__"],
                    group_interval="30",
                    group_wait="30",
                    level="P0",
                    repeat_interval="30",
                ),
                volcengine.vmp.NotifyGroupPolicyLevelArgs(
                    group_bies=["__rule__"],
                    group_interval="45",
                    group_wait="40",
                    level="P1",
                    repeat_interval="30",
                ),
            ])
        ```

        ## Import

        VMP Notify Group Policy can be imported using the id, e.g.

        ```sh
        $ pulumi import volcengine:vmp/notifyGroupPolicy:NotifyGroupPolicy default 60dde3ca-951c-4c05-8777-e5a7caa07ad6
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: The description of the notify group policy.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['NotifyGroupPolicyLevelArgs']]]] levels: The levels of the notify group policy. Levels must be registered in three (`P0`, `P1`, `P2`) aggregation strategies, and `Level` cannot be repeated.
        :param pulumi.Input[str] name: The name of the notify group policy.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: NotifyGroupPolicyArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to manage vmp notify group policy
        ## Example Usage

        ```python
        import pulumi
        import pulumi_volcengine as volcengine

        foo = volcengine.vmp.NotifyGroupPolicy("foo",
            description="acc-test-1",
            levels=[
                volcengine.vmp.NotifyGroupPolicyLevelArgs(
                    group_bies=["__rule__"],
                    group_interval="30",
                    group_wait="35",
                    level="P2",
                    repeat_interval="30",
                ),
                volcengine.vmp.NotifyGroupPolicyLevelArgs(
                    group_bies=["__rule__"],
                    group_interval="30",
                    group_wait="30",
                    level="P0",
                    repeat_interval="30",
                ),
                volcengine.vmp.NotifyGroupPolicyLevelArgs(
                    group_bies=["__rule__"],
                    group_interval="45",
                    group_wait="40",
                    level="P1",
                    repeat_interval="30",
                ),
            ])
        ```

        ## Import

        VMP Notify Group Policy can be imported using the id, e.g.

        ```sh
        $ pulumi import volcengine:vmp/notifyGroupPolicy:NotifyGroupPolicy default 60dde3ca-951c-4c05-8777-e5a7caa07ad6
        ```

        :param str resource_name: The name of the resource.
        :param NotifyGroupPolicyArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(NotifyGroupPolicyArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 levels: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['NotifyGroupPolicyLevelArgs']]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = NotifyGroupPolicyArgs.__new__(NotifyGroupPolicyArgs)

            __props__.__dict__["description"] = description
            if levels is None and not opts.urn:
                raise TypeError("Missing required property 'levels'")
            __props__.__dict__["levels"] = levels
            __props__.__dict__["name"] = name
        super(NotifyGroupPolicy, __self__).__init__(
            'volcengine:vmp/notifyGroupPolicy:NotifyGroupPolicy',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            description: Optional[pulumi.Input[str]] = None,
            levels: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['NotifyGroupPolicyLevelArgs']]]]] = None,
            name: Optional[pulumi.Input[str]] = None) -> 'NotifyGroupPolicy':
        """
        Get an existing NotifyGroupPolicy resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: The description of the notify group policy.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['NotifyGroupPolicyLevelArgs']]]] levels: The levels of the notify group policy. Levels must be registered in three (`P0`, `P1`, `P2`) aggregation strategies, and `Level` cannot be repeated.
        :param pulumi.Input[str] name: The name of the notify group policy.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _NotifyGroupPolicyState.__new__(_NotifyGroupPolicyState)

        __props__.__dict__["description"] = description
        __props__.__dict__["levels"] = levels
        __props__.__dict__["name"] = name
        return NotifyGroupPolicy(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        The description of the notify group policy.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def levels(self) -> pulumi.Output[Sequence['outputs.NotifyGroupPolicyLevel']]:
        """
        The levels of the notify group policy. Levels must be registered in three (`P0`, `P1`, `P2`) aggregation strategies, and `Level` cannot be repeated.
        """
        return pulumi.get(self, "levels")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the notify group policy.
        """
        return pulumi.get(self, "name")

