# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['TrafficMirrorSessionArgs', 'TrafficMirrorSession']

@pulumi.input_type
class TrafficMirrorSessionArgs:
    def __init__(__self__, *,
                 network_interface_id: pulumi.Input[str],
                 priority: pulumi.Input[int],
                 traffic_mirror_filter_id: pulumi.Input[str],
                 traffic_mirror_target_id: pulumi.Input[str],
                 description: Optional[pulumi.Input[str]] = None,
                 packet_length: Optional[pulumi.Input[int]] = None,
                 project_name: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input['TrafficMirrorSessionTagArgs']]]] = None,
                 traffic_mirror_session_name: Optional[pulumi.Input[str]] = None,
                 virtual_network_id: Optional[pulumi.Input[int]] = None):
        """
        The set of arguments for constructing a TrafficMirrorSession resource.
        :param pulumi.Input[str] network_interface_id: The ID of network interface.
        :param pulumi.Input[int] priority: The priority of traffic mirror session. Valid values: 1~32766.
        :param pulumi.Input[str] traffic_mirror_filter_id: The ID of traffic mirror filter.
        :param pulumi.Input[str] traffic_mirror_target_id: The ID of traffic mirror target.
        :param pulumi.Input[str] description: The description of the traffic mirror session.
        :param pulumi.Input[int] packet_length: The packet length of traffic mirror session.
        :param pulumi.Input[str] project_name: The project name of traffic mirror session.
        :param pulumi.Input[Sequence[pulumi.Input['TrafficMirrorSessionTagArgs']]] tags: Tags.
        :param pulumi.Input[str] traffic_mirror_session_name: The name of the traffic mirror session.
        :param pulumi.Input[int] virtual_network_id: The ID of virtual network.
        """
        pulumi.set(__self__, "network_interface_id", network_interface_id)
        pulumi.set(__self__, "priority", priority)
        pulumi.set(__self__, "traffic_mirror_filter_id", traffic_mirror_filter_id)
        pulumi.set(__self__, "traffic_mirror_target_id", traffic_mirror_target_id)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if packet_length is not None:
            pulumi.set(__self__, "packet_length", packet_length)
        if project_name is not None:
            pulumi.set(__self__, "project_name", project_name)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if traffic_mirror_session_name is not None:
            pulumi.set(__self__, "traffic_mirror_session_name", traffic_mirror_session_name)
        if virtual_network_id is not None:
            pulumi.set(__self__, "virtual_network_id", virtual_network_id)

    @property
    @pulumi.getter(name="networkInterfaceId")
    def network_interface_id(self) -> pulumi.Input[str]:
        """
        The ID of network interface.
        """
        return pulumi.get(self, "network_interface_id")

    @network_interface_id.setter
    def network_interface_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "network_interface_id", value)

    @property
    @pulumi.getter
    def priority(self) -> pulumi.Input[int]:
        """
        The priority of traffic mirror session. Valid values: 1~32766.
        """
        return pulumi.get(self, "priority")

    @priority.setter
    def priority(self, value: pulumi.Input[int]):
        pulumi.set(self, "priority", value)

    @property
    @pulumi.getter(name="trafficMirrorFilterId")
    def traffic_mirror_filter_id(self) -> pulumi.Input[str]:
        """
        The ID of traffic mirror filter.
        """
        return pulumi.get(self, "traffic_mirror_filter_id")

    @traffic_mirror_filter_id.setter
    def traffic_mirror_filter_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "traffic_mirror_filter_id", value)

    @property
    @pulumi.getter(name="trafficMirrorTargetId")
    def traffic_mirror_target_id(self) -> pulumi.Input[str]:
        """
        The ID of traffic mirror target.
        """
        return pulumi.get(self, "traffic_mirror_target_id")

    @traffic_mirror_target_id.setter
    def traffic_mirror_target_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "traffic_mirror_target_id", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        The description of the traffic mirror session.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="packetLength")
    def packet_length(self) -> Optional[pulumi.Input[int]]:
        """
        The packet length of traffic mirror session.
        """
        return pulumi.get(self, "packet_length")

    @packet_length.setter
    def packet_length(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "packet_length", value)

    @property
    @pulumi.getter(name="projectName")
    def project_name(self) -> Optional[pulumi.Input[str]]:
        """
        The project name of traffic mirror session.
        """
        return pulumi.get(self, "project_name")

    @project_name.setter
    def project_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "project_name", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['TrafficMirrorSessionTagArgs']]]]:
        """
        Tags.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['TrafficMirrorSessionTagArgs']]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter(name="trafficMirrorSessionName")
    def traffic_mirror_session_name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the traffic mirror session.
        """
        return pulumi.get(self, "traffic_mirror_session_name")

    @traffic_mirror_session_name.setter
    def traffic_mirror_session_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "traffic_mirror_session_name", value)

    @property
    @pulumi.getter(name="virtualNetworkId")
    def virtual_network_id(self) -> Optional[pulumi.Input[int]]:
        """
        The ID of virtual network.
        """
        return pulumi.get(self, "virtual_network_id")

    @virtual_network_id.setter
    def virtual_network_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "virtual_network_id", value)


@pulumi.input_type
class _TrafficMirrorSessionState:
    def __init__(__self__, *,
                 business_status: Optional[pulumi.Input[str]] = None,
                 created_at: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 lock_reason: Optional[pulumi.Input[str]] = None,
                 network_interface_id: Optional[pulumi.Input[str]] = None,
                 packet_length: Optional[pulumi.Input[int]] = None,
                 priority: Optional[pulumi.Input[int]] = None,
                 project_name: Optional[pulumi.Input[str]] = None,
                 status: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input['TrafficMirrorSessionTagArgs']]]] = None,
                 traffic_mirror_filter_id: Optional[pulumi.Input[str]] = None,
                 traffic_mirror_session_name: Optional[pulumi.Input[str]] = None,
                 traffic_mirror_target_id: Optional[pulumi.Input[str]] = None,
                 updated_at: Optional[pulumi.Input[str]] = None,
                 virtual_network_id: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering TrafficMirrorSession resources.
        :param pulumi.Input[str] business_status: The business status of traffic mirror session.
        :param pulumi.Input[str] created_at: The create time of traffic mirror session.
        :param pulumi.Input[str] description: The description of the traffic mirror session.
        :param pulumi.Input[str] lock_reason: The lock reason of traffic mirror session.
        :param pulumi.Input[str] network_interface_id: The ID of network interface.
        :param pulumi.Input[int] packet_length: The packet length of traffic mirror session.
        :param pulumi.Input[int] priority: The priority of traffic mirror session. Valid values: 1~32766.
        :param pulumi.Input[str] project_name: The project name of traffic mirror session.
        :param pulumi.Input[str] status: The status of traffic mirror session.
        :param pulumi.Input[Sequence[pulumi.Input['TrafficMirrorSessionTagArgs']]] tags: Tags.
        :param pulumi.Input[str] traffic_mirror_filter_id: The ID of traffic mirror filter.
        :param pulumi.Input[str] traffic_mirror_session_name: The name of the traffic mirror session.
        :param pulumi.Input[str] traffic_mirror_target_id: The ID of traffic mirror target.
        :param pulumi.Input[str] updated_at: The update time of traffic mirror session.
        :param pulumi.Input[int] virtual_network_id: The ID of virtual network.
        """
        if business_status is not None:
            pulumi.set(__self__, "business_status", business_status)
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if lock_reason is not None:
            pulumi.set(__self__, "lock_reason", lock_reason)
        if network_interface_id is not None:
            pulumi.set(__self__, "network_interface_id", network_interface_id)
        if packet_length is not None:
            pulumi.set(__self__, "packet_length", packet_length)
        if priority is not None:
            pulumi.set(__self__, "priority", priority)
        if project_name is not None:
            pulumi.set(__self__, "project_name", project_name)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if traffic_mirror_filter_id is not None:
            pulumi.set(__self__, "traffic_mirror_filter_id", traffic_mirror_filter_id)
        if traffic_mirror_session_name is not None:
            pulumi.set(__self__, "traffic_mirror_session_name", traffic_mirror_session_name)
        if traffic_mirror_target_id is not None:
            pulumi.set(__self__, "traffic_mirror_target_id", traffic_mirror_target_id)
        if updated_at is not None:
            pulumi.set(__self__, "updated_at", updated_at)
        if virtual_network_id is not None:
            pulumi.set(__self__, "virtual_network_id", virtual_network_id)

    @property
    @pulumi.getter(name="businessStatus")
    def business_status(self) -> Optional[pulumi.Input[str]]:
        """
        The business status of traffic mirror session.
        """
        return pulumi.get(self, "business_status")

    @business_status.setter
    def business_status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "business_status", value)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[pulumi.Input[str]]:
        """
        The create time of traffic mirror session.
        """
        return pulumi.get(self, "created_at")

    @created_at.setter
    def created_at(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "created_at", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        The description of the traffic mirror session.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="lockReason")
    def lock_reason(self) -> Optional[pulumi.Input[str]]:
        """
        The lock reason of traffic mirror session.
        """
        return pulumi.get(self, "lock_reason")

    @lock_reason.setter
    def lock_reason(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "lock_reason", value)

    @property
    @pulumi.getter(name="networkInterfaceId")
    def network_interface_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of network interface.
        """
        return pulumi.get(self, "network_interface_id")

    @network_interface_id.setter
    def network_interface_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "network_interface_id", value)

    @property
    @pulumi.getter(name="packetLength")
    def packet_length(self) -> Optional[pulumi.Input[int]]:
        """
        The packet length of traffic mirror session.
        """
        return pulumi.get(self, "packet_length")

    @packet_length.setter
    def packet_length(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "packet_length", value)

    @property
    @pulumi.getter
    def priority(self) -> Optional[pulumi.Input[int]]:
        """
        The priority of traffic mirror session. Valid values: 1~32766.
        """
        return pulumi.get(self, "priority")

    @priority.setter
    def priority(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "priority", value)

    @property
    @pulumi.getter(name="projectName")
    def project_name(self) -> Optional[pulumi.Input[str]]:
        """
        The project name of traffic mirror session.
        """
        return pulumi.get(self, "project_name")

    @project_name.setter
    def project_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "project_name", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[str]]:
        """
        The status of traffic mirror session.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "status", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['TrafficMirrorSessionTagArgs']]]]:
        """
        Tags.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['TrafficMirrorSessionTagArgs']]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter(name="trafficMirrorFilterId")
    def traffic_mirror_filter_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of traffic mirror filter.
        """
        return pulumi.get(self, "traffic_mirror_filter_id")

    @traffic_mirror_filter_id.setter
    def traffic_mirror_filter_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "traffic_mirror_filter_id", value)

    @property
    @pulumi.getter(name="trafficMirrorSessionName")
    def traffic_mirror_session_name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the traffic mirror session.
        """
        return pulumi.get(self, "traffic_mirror_session_name")

    @traffic_mirror_session_name.setter
    def traffic_mirror_session_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "traffic_mirror_session_name", value)

    @property
    @pulumi.getter(name="trafficMirrorTargetId")
    def traffic_mirror_target_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of traffic mirror target.
        """
        return pulumi.get(self, "traffic_mirror_target_id")

    @traffic_mirror_target_id.setter
    def traffic_mirror_target_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "traffic_mirror_target_id", value)

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> Optional[pulumi.Input[str]]:
        """
        The update time of traffic mirror session.
        """
        return pulumi.get(self, "updated_at")

    @updated_at.setter
    def updated_at(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "updated_at", value)

    @property
    @pulumi.getter(name="virtualNetworkId")
    def virtual_network_id(self) -> Optional[pulumi.Input[int]]:
        """
        The ID of virtual network.
        """
        return pulumi.get(self, "virtual_network_id")

    @virtual_network_id.setter
    def virtual_network_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "virtual_network_id", value)


class TrafficMirrorSession(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 network_interface_id: Optional[pulumi.Input[str]] = None,
                 packet_length: Optional[pulumi.Input[int]] = None,
                 priority: Optional[pulumi.Input[int]] = None,
                 project_name: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['TrafficMirrorSessionTagArgs']]]]] = None,
                 traffic_mirror_filter_id: Optional[pulumi.Input[str]] = None,
                 traffic_mirror_session_name: Optional[pulumi.Input[str]] = None,
                 traffic_mirror_target_id: Optional[pulumi.Input[str]] = None,
                 virtual_network_id: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        Provides a resource to manage traffic mirror session
        ## Example Usage

        ```python
        import pulumi
        import pulumi_volcengine as volcengine

        foo_zones = volcengine.ecs.get_zones()
        foo_vpc = volcengine.vpc.Vpc("fooVpc",
            vpc_name="acc-test-vpc",
            cidr_block="172.16.0.0/16")
        foo_subnet = volcengine.vpc.Subnet("fooSubnet",
            subnet_name="acc-test-subnet",
            cidr_block="172.16.0.0/24",
            zone_id=foo_zones.zones[0].id,
            vpc_id=foo_vpc.id)
        foo_security_group = volcengine.vpc.SecurityGroup("fooSecurityGroup",
            security_group_name="acc-test-sg",
            vpc_id=foo_vpc.id)
        foo_images = volcengine.ecs.get_images(os_type="Linux",
            visibility="public",
            instance_type_id="ecs.g3il.large")
        foo_instance = volcengine.ecs.Instance("fooInstance",
            instance_name="acc-test-ecs",
            description="acc-test",
            host_name="tf-acc-test",
            image_id=foo_images.images[0].image_id,
            instance_type="ecs.g3il.large",
            password="93f0cb0614Aab12",
            instance_charge_type="PostPaid",
            system_volume_type="ESSD_PL0",
            system_volume_size=40,
            subnet_id=foo_subnet.id,
            security_group_ids=[foo_security_group.id],
            project_name="default",
            tags=[volcengine.ecs.InstanceTagArgs(
                key="k1",
                value="v1",
            )])
        foo_network_interface = volcengine.vpc.NetworkInterface("fooNetworkInterface",
            network_interface_name="acc-test-eni",
            description="acc-test",
            subnet_id=foo_subnet.id,
            security_group_ids=[foo_security_group.id],
            primary_ip_address="172.16.0.253",
            port_security_enabled=False,
            private_ip_addresses=["172.16.0.2"],
            project_name="default",
            tags=[volcengine.vpc.NetworkInterfaceTagArgs(
                key="k1",
                value="v1",
            )])
        foo_source_network_interface = volcengine.vpc.NetworkInterface("foo-sourceNetworkInterface",
            network_interface_name="acc-test-eni",
            description="acc-test",
            subnet_id=foo_subnet.id,
            security_group_ids=[foo_security_group.id],
            primary_ip_address="172.16.0.252",
            port_security_enabled=False,
            private_ip_addresses=["172.16.0.5"],
            project_name="default",
            tags=[volcengine.vpc.NetworkInterfaceTagArgs(
                key="k1",
                value="v1",
            )])
        foo_network_interface_attach = volcengine.vpc.NetworkInterfaceAttach("fooNetworkInterfaceAttach",
            network_interface_id=foo_network_interface.id,
            instance_id=foo_instance.id)
        foo_source_network_interface_attach = volcengine.vpc.NetworkInterfaceAttach("foo-sourceNetworkInterfaceAttach",
            network_interface_id=foo_source_network_interface.id,
            instance_id=foo_instance.id)
        foo_traffic_mirror_target = volcengine.vpc.TrafficMirrorTarget("fooTrafficMirrorTarget",
            instance_type="NetworkInterface",
            instance_id=foo_network_interface.id,
            traffic_mirror_target_name="acc-test-traffic-mirror-target",
            description="acc-test",
            project_name="default",
            tags=[volcengine.vpc.TrafficMirrorTargetTagArgs(
                key="k1",
                value="v1",
            )],
            opts=pulumi.ResourceOptions(depends_on=[foo_network_interface_attach]))
        foo_traffic_mirror_filter = volcengine.vpc.TrafficMirrorFilter("fooTrafficMirrorFilter",
            traffic_mirror_filter_name="acc-test-traffic-mirror-filter",
            description="acc-test",
            project_name="default",
            tags=[volcengine.vpc.TrafficMirrorFilterTagArgs(
                key="k1",
                value="v1",
            )])
        foo_traffic_mirror_session = volcengine.vpc.TrafficMirrorSession("fooTrafficMirrorSession",
            traffic_mirror_filter_id=foo_traffic_mirror_filter.id,
            traffic_mirror_target_id=foo_traffic_mirror_target.id,
            traffic_mirror_session_name="acc-test-traffic-mirror-session",
            description="acc-test",
            network_interface_id=foo_source_network_interface.id,
            virtual_network_id=10,
            packet_length=1000,
            priority=1,
            project_name="default",
            tags=[volcengine.vpc.TrafficMirrorSessionTagArgs(
                key="k1",
                value="v1",
            )],
            opts=pulumi.ResourceOptions(depends_on=[foo_source_network_interface_attach]))
        ```

        ## Import

        TrafficMirrorSession can be imported using the id, e.g.

        ```sh
        $ pulumi import volcengine:vpc/trafficMirrorSession:TrafficMirrorSession default resource_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: The description of the traffic mirror session.
        :param pulumi.Input[str] network_interface_id: The ID of network interface.
        :param pulumi.Input[int] packet_length: The packet length of traffic mirror session.
        :param pulumi.Input[int] priority: The priority of traffic mirror session. Valid values: 1~32766.
        :param pulumi.Input[str] project_name: The project name of traffic mirror session.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['TrafficMirrorSessionTagArgs']]]] tags: Tags.
        :param pulumi.Input[str] traffic_mirror_filter_id: The ID of traffic mirror filter.
        :param pulumi.Input[str] traffic_mirror_session_name: The name of the traffic mirror session.
        :param pulumi.Input[str] traffic_mirror_target_id: The ID of traffic mirror target.
        :param pulumi.Input[int] virtual_network_id: The ID of virtual network.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: TrafficMirrorSessionArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to manage traffic mirror session
        ## Example Usage

        ```python
        import pulumi
        import pulumi_volcengine as volcengine

        foo_zones = volcengine.ecs.get_zones()
        foo_vpc = volcengine.vpc.Vpc("fooVpc",
            vpc_name="acc-test-vpc",
            cidr_block="172.16.0.0/16")
        foo_subnet = volcengine.vpc.Subnet("fooSubnet",
            subnet_name="acc-test-subnet",
            cidr_block="172.16.0.0/24",
            zone_id=foo_zones.zones[0].id,
            vpc_id=foo_vpc.id)
        foo_security_group = volcengine.vpc.SecurityGroup("fooSecurityGroup",
            security_group_name="acc-test-sg",
            vpc_id=foo_vpc.id)
        foo_images = volcengine.ecs.get_images(os_type="Linux",
            visibility="public",
            instance_type_id="ecs.g3il.large")
        foo_instance = volcengine.ecs.Instance("fooInstance",
            instance_name="acc-test-ecs",
            description="acc-test",
            host_name="tf-acc-test",
            image_id=foo_images.images[0].image_id,
            instance_type="ecs.g3il.large",
            password="93f0cb0614Aab12",
            instance_charge_type="PostPaid",
            system_volume_type="ESSD_PL0",
            system_volume_size=40,
            subnet_id=foo_subnet.id,
            security_group_ids=[foo_security_group.id],
            project_name="default",
            tags=[volcengine.ecs.InstanceTagArgs(
                key="k1",
                value="v1",
            )])
        foo_network_interface = volcengine.vpc.NetworkInterface("fooNetworkInterface",
            network_interface_name="acc-test-eni",
            description="acc-test",
            subnet_id=foo_subnet.id,
            security_group_ids=[foo_security_group.id],
            primary_ip_address="172.16.0.253",
            port_security_enabled=False,
            private_ip_addresses=["172.16.0.2"],
            project_name="default",
            tags=[volcengine.vpc.NetworkInterfaceTagArgs(
                key="k1",
                value="v1",
            )])
        foo_source_network_interface = volcengine.vpc.NetworkInterface("foo-sourceNetworkInterface",
            network_interface_name="acc-test-eni",
            description="acc-test",
            subnet_id=foo_subnet.id,
            security_group_ids=[foo_security_group.id],
            primary_ip_address="172.16.0.252",
            port_security_enabled=False,
            private_ip_addresses=["172.16.0.5"],
            project_name="default",
            tags=[volcengine.vpc.NetworkInterfaceTagArgs(
                key="k1",
                value="v1",
            )])
        foo_network_interface_attach = volcengine.vpc.NetworkInterfaceAttach("fooNetworkInterfaceAttach",
            network_interface_id=foo_network_interface.id,
            instance_id=foo_instance.id)
        foo_source_network_interface_attach = volcengine.vpc.NetworkInterfaceAttach("foo-sourceNetworkInterfaceAttach",
            network_interface_id=foo_source_network_interface.id,
            instance_id=foo_instance.id)
        foo_traffic_mirror_target = volcengine.vpc.TrafficMirrorTarget("fooTrafficMirrorTarget",
            instance_type="NetworkInterface",
            instance_id=foo_network_interface.id,
            traffic_mirror_target_name="acc-test-traffic-mirror-target",
            description="acc-test",
            project_name="default",
            tags=[volcengine.vpc.TrafficMirrorTargetTagArgs(
                key="k1",
                value="v1",
            )],
            opts=pulumi.ResourceOptions(depends_on=[foo_network_interface_attach]))
        foo_traffic_mirror_filter = volcengine.vpc.TrafficMirrorFilter("fooTrafficMirrorFilter",
            traffic_mirror_filter_name="acc-test-traffic-mirror-filter",
            description="acc-test",
            project_name="default",
            tags=[volcengine.vpc.TrafficMirrorFilterTagArgs(
                key="k1",
                value="v1",
            )])
        foo_traffic_mirror_session = volcengine.vpc.TrafficMirrorSession("fooTrafficMirrorSession",
            traffic_mirror_filter_id=foo_traffic_mirror_filter.id,
            traffic_mirror_target_id=foo_traffic_mirror_target.id,
            traffic_mirror_session_name="acc-test-traffic-mirror-session",
            description="acc-test",
            network_interface_id=foo_source_network_interface.id,
            virtual_network_id=10,
            packet_length=1000,
            priority=1,
            project_name="default",
            tags=[volcengine.vpc.TrafficMirrorSessionTagArgs(
                key="k1",
                value="v1",
            )],
            opts=pulumi.ResourceOptions(depends_on=[foo_source_network_interface_attach]))
        ```

        ## Import

        TrafficMirrorSession can be imported using the id, e.g.

        ```sh
        $ pulumi import volcengine:vpc/trafficMirrorSession:TrafficMirrorSession default resource_id
        ```

        :param str resource_name: The name of the resource.
        :param TrafficMirrorSessionArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(TrafficMirrorSessionArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 network_interface_id: Optional[pulumi.Input[str]] = None,
                 packet_length: Optional[pulumi.Input[int]] = None,
                 priority: Optional[pulumi.Input[int]] = None,
                 project_name: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['TrafficMirrorSessionTagArgs']]]]] = None,
                 traffic_mirror_filter_id: Optional[pulumi.Input[str]] = None,
                 traffic_mirror_session_name: Optional[pulumi.Input[str]] = None,
                 traffic_mirror_target_id: Optional[pulumi.Input[str]] = None,
                 virtual_network_id: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = TrafficMirrorSessionArgs.__new__(TrafficMirrorSessionArgs)

            __props__.__dict__["description"] = description
            if network_interface_id is None and not opts.urn:
                raise TypeError("Missing required property 'network_interface_id'")
            __props__.__dict__["network_interface_id"] = network_interface_id
            __props__.__dict__["packet_length"] = packet_length
            if priority is None and not opts.urn:
                raise TypeError("Missing required property 'priority'")
            __props__.__dict__["priority"] = priority
            __props__.__dict__["project_name"] = project_name
            __props__.__dict__["tags"] = tags
            if traffic_mirror_filter_id is None and not opts.urn:
                raise TypeError("Missing required property 'traffic_mirror_filter_id'")
            __props__.__dict__["traffic_mirror_filter_id"] = traffic_mirror_filter_id
            __props__.__dict__["traffic_mirror_session_name"] = traffic_mirror_session_name
            if traffic_mirror_target_id is None and not opts.urn:
                raise TypeError("Missing required property 'traffic_mirror_target_id'")
            __props__.__dict__["traffic_mirror_target_id"] = traffic_mirror_target_id
            __props__.__dict__["virtual_network_id"] = virtual_network_id
            __props__.__dict__["business_status"] = None
            __props__.__dict__["created_at"] = None
            __props__.__dict__["lock_reason"] = None
            __props__.__dict__["status"] = None
            __props__.__dict__["updated_at"] = None
        super(TrafficMirrorSession, __self__).__init__(
            'volcengine:vpc/trafficMirrorSession:TrafficMirrorSession',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            business_status: Optional[pulumi.Input[str]] = None,
            created_at: Optional[pulumi.Input[str]] = None,
            description: Optional[pulumi.Input[str]] = None,
            lock_reason: Optional[pulumi.Input[str]] = None,
            network_interface_id: Optional[pulumi.Input[str]] = None,
            packet_length: Optional[pulumi.Input[int]] = None,
            priority: Optional[pulumi.Input[int]] = None,
            project_name: Optional[pulumi.Input[str]] = None,
            status: Optional[pulumi.Input[str]] = None,
            tags: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['TrafficMirrorSessionTagArgs']]]]] = None,
            traffic_mirror_filter_id: Optional[pulumi.Input[str]] = None,
            traffic_mirror_session_name: Optional[pulumi.Input[str]] = None,
            traffic_mirror_target_id: Optional[pulumi.Input[str]] = None,
            updated_at: Optional[pulumi.Input[str]] = None,
            virtual_network_id: Optional[pulumi.Input[int]] = None) -> 'TrafficMirrorSession':
        """
        Get an existing TrafficMirrorSession resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] business_status: The business status of traffic mirror session.
        :param pulumi.Input[str] created_at: The create time of traffic mirror session.
        :param pulumi.Input[str] description: The description of the traffic mirror session.
        :param pulumi.Input[str] lock_reason: The lock reason of traffic mirror session.
        :param pulumi.Input[str] network_interface_id: The ID of network interface.
        :param pulumi.Input[int] packet_length: The packet length of traffic mirror session.
        :param pulumi.Input[int] priority: The priority of traffic mirror session. Valid values: 1~32766.
        :param pulumi.Input[str] project_name: The project name of traffic mirror session.
        :param pulumi.Input[str] status: The status of traffic mirror session.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['TrafficMirrorSessionTagArgs']]]] tags: Tags.
        :param pulumi.Input[str] traffic_mirror_filter_id: The ID of traffic mirror filter.
        :param pulumi.Input[str] traffic_mirror_session_name: The name of the traffic mirror session.
        :param pulumi.Input[str] traffic_mirror_target_id: The ID of traffic mirror target.
        :param pulumi.Input[str] updated_at: The update time of traffic mirror session.
        :param pulumi.Input[int] virtual_network_id: The ID of virtual network.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _TrafficMirrorSessionState.__new__(_TrafficMirrorSessionState)

        __props__.__dict__["business_status"] = business_status
        __props__.__dict__["created_at"] = created_at
        __props__.__dict__["description"] = description
        __props__.__dict__["lock_reason"] = lock_reason
        __props__.__dict__["network_interface_id"] = network_interface_id
        __props__.__dict__["packet_length"] = packet_length
        __props__.__dict__["priority"] = priority
        __props__.__dict__["project_name"] = project_name
        __props__.__dict__["status"] = status
        __props__.__dict__["tags"] = tags
        __props__.__dict__["traffic_mirror_filter_id"] = traffic_mirror_filter_id
        __props__.__dict__["traffic_mirror_session_name"] = traffic_mirror_session_name
        __props__.__dict__["traffic_mirror_target_id"] = traffic_mirror_target_id
        __props__.__dict__["updated_at"] = updated_at
        __props__.__dict__["virtual_network_id"] = virtual_network_id
        return TrafficMirrorSession(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="businessStatus")
    def business_status(self) -> pulumi.Output[str]:
        """
        The business status of traffic mirror session.
        """
        return pulumi.get(self, "business_status")

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> pulumi.Output[str]:
        """
        The create time of traffic mirror session.
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        The description of the traffic mirror session.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="lockReason")
    def lock_reason(self) -> pulumi.Output[str]:
        """
        The lock reason of traffic mirror session.
        """
        return pulumi.get(self, "lock_reason")

    @property
    @pulumi.getter(name="networkInterfaceId")
    def network_interface_id(self) -> pulumi.Output[str]:
        """
        The ID of network interface.
        """
        return pulumi.get(self, "network_interface_id")

    @property
    @pulumi.getter(name="packetLength")
    def packet_length(self) -> pulumi.Output[int]:
        """
        The packet length of traffic mirror session.
        """
        return pulumi.get(self, "packet_length")

    @property
    @pulumi.getter
    def priority(self) -> pulumi.Output[int]:
        """
        The priority of traffic mirror session. Valid values: 1~32766.
        """
        return pulumi.get(self, "priority")

    @property
    @pulumi.getter(name="projectName")
    def project_name(self) -> pulumi.Output[str]:
        """
        The project name of traffic mirror session.
        """
        return pulumi.get(self, "project_name")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[str]:
        """
        The status of traffic mirror session.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Sequence['outputs.TrafficMirrorSessionTag']]]:
        """
        Tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter(name="trafficMirrorFilterId")
    def traffic_mirror_filter_id(self) -> pulumi.Output[str]:
        """
        The ID of traffic mirror filter.
        """
        return pulumi.get(self, "traffic_mirror_filter_id")

    @property
    @pulumi.getter(name="trafficMirrorSessionName")
    def traffic_mirror_session_name(self) -> pulumi.Output[str]:
        """
        The name of the traffic mirror session.
        """
        return pulumi.get(self, "traffic_mirror_session_name")

    @property
    @pulumi.getter(name="trafficMirrorTargetId")
    def traffic_mirror_target_id(self) -> pulumi.Output[str]:
        """
        The ID of traffic mirror target.
        """
        return pulumi.get(self, "traffic_mirror_target_id")

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> pulumi.Output[str]:
        """
        The update time of traffic mirror session.
        """
        return pulumi.get(self, "updated_at")

    @property
    @pulumi.getter(name="virtualNetworkId")
    def virtual_network_id(self) -> pulumi.Output[int]:
        """
        The ID of virtual network.
        """
        return pulumi.get(self, "virtual_network_id")

