# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'BotAnalyseProtectRulesResult',
    'AwaitableBotAnalyseProtectRulesResult',
    'bot_analyse_protect_rules',
    'bot_analyse_protect_rules_output',
]

warnings.warn("""volcengine.waf.BotAnalyseProtectRules has been deprecated in favor of volcengine.waf.getBotAnalyseProtectRules""", DeprecationWarning)

@pulumi.output_type
class BotAnalyseProtectRulesResult:
    """
    A collection of values returned by BotAnalyseProtectRules.
    """
    def __init__(__self__, bot_space=None, datas=None, host=None, id=None, name=None, name_regex=None, output_file=None, path=None, project_name=None, rule_tag=None, total_count=None):
        if bot_space and not isinstance(bot_space, str):
            raise TypeError("Expected argument 'bot_space' to be a str")
        pulumi.set(__self__, "bot_space", bot_space)
        if datas and not isinstance(datas, list):
            raise TypeError("Expected argument 'datas' to be a list")
        pulumi.set(__self__, "datas", datas)
        if host and not isinstance(host, str):
            raise TypeError("Expected argument 'host' to be a str")
        pulumi.set(__self__, "host", host)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if name_regex and not isinstance(name_regex, str):
            raise TypeError("Expected argument 'name_regex' to be a str")
        pulumi.set(__self__, "name_regex", name_regex)
        if output_file and not isinstance(output_file, str):
            raise TypeError("Expected argument 'output_file' to be a str")
        pulumi.set(__self__, "output_file", output_file)
        if path and not isinstance(path, str):
            raise TypeError("Expected argument 'path' to be a str")
        pulumi.set(__self__, "path", path)
        if project_name and not isinstance(project_name, str):
            raise TypeError("Expected argument 'project_name' to be a str")
        pulumi.set(__self__, "project_name", project_name)
        if rule_tag and not isinstance(rule_tag, str):
            raise TypeError("Expected argument 'rule_tag' to be a str")
        pulumi.set(__self__, "rule_tag", rule_tag)
        if total_count and not isinstance(total_count, int):
            raise TypeError("Expected argument 'total_count' to be a int")
        pulumi.set(__self__, "total_count", total_count)

    @property
    @pulumi.getter(name="botSpace")
    def bot_space(self) -> str:
        return pulumi.get(self, "bot_space")

    @property
    @pulumi.getter
    def datas(self) -> Sequence['outputs.BotAnalyseProtectRulesDataResult']:
        """
        The details of the Bot rules.
        """
        return pulumi.get(self, "datas")

    @property
    @pulumi.getter
    def host(self) -> str:
        """
        The domain name where the protection rule is located.
        """
        return pulumi.get(self, "host")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        The name of rule.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="nameRegex")
    def name_regex(self) -> Optional[str]:
        return pulumi.get(self, "name_regex")

    @property
    @pulumi.getter(name="outputFile")
    def output_file(self) -> Optional[str]:
        return pulumi.get(self, "output_file")

    @property
    @pulumi.getter
    def path(self) -> Optional[str]:
        """
        Request path.
        """
        return pulumi.get(self, "path")

    @property
    @pulumi.getter(name="projectName")
    def project_name(self) -> Optional[str]:
        return pulumi.get(self, "project_name")

    @property
    @pulumi.getter(name="ruleTag")
    def rule_tag(self) -> Optional[str]:
        """
        Rule label, that is, the complete rule ID.
        """
        return pulumi.get(self, "rule_tag")

    @property
    @pulumi.getter(name="totalCount")
    def total_count(self) -> int:
        """
        The total count of query.
        """
        return pulumi.get(self, "total_count")


class AwaitableBotAnalyseProtectRulesResult(BotAnalyseProtectRulesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return BotAnalyseProtectRulesResult(
            bot_space=self.bot_space,
            datas=self.datas,
            host=self.host,
            id=self.id,
            name=self.name,
            name_regex=self.name_regex,
            output_file=self.output_file,
            path=self.path,
            project_name=self.project_name,
            rule_tag=self.rule_tag,
            total_count=self.total_count)


def bot_analyse_protect_rules(bot_space: Optional[str] = None,
                              host: Optional[str] = None,
                              name: Optional[str] = None,
                              name_regex: Optional[str] = None,
                              output_file: Optional[str] = None,
                              path: Optional[str] = None,
                              project_name: Optional[str] = None,
                              rule_tag: Optional[str] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableBotAnalyseProtectRulesResult:
    """
    Use this data source to query detailed information of waf bot analyse protect rules
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo = volcengine.waf.get_bot_analyse_protect_rules(bot_space="BotRepeat",
        host="www.tf-test.com")
    ```


    :param str bot_space: Bot protection rule type.
    :param str host: Website domain names that require the setting of protection rules.
    :param str name: The name of the rule.
    :param str name_regex: A Name Regex of Resource.
    :param str output_file: File name where to save data source results.
    :param str path: Protective path.
    :param str project_name: The name of the project to which your domain names belong.
    :param str rule_tag: Unique identification of rules.
    """
    pulumi.log.warn("""bot_analyse_protect_rules is deprecated: volcengine.waf.BotAnalyseProtectRules has been deprecated in favor of volcengine.waf.getBotAnalyseProtectRules""")
    __args__ = dict()
    __args__['botSpace'] = bot_space
    __args__['host'] = host
    __args__['name'] = name
    __args__['nameRegex'] = name_regex
    __args__['outputFile'] = output_file
    __args__['path'] = path
    __args__['projectName'] = project_name
    __args__['ruleTag'] = rule_tag
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('volcengine:waf/botAnalyseProtectRules:BotAnalyseProtectRules', __args__, opts=opts, typ=BotAnalyseProtectRulesResult).value

    return AwaitableBotAnalyseProtectRulesResult(
        bot_space=pulumi.get(__ret__, 'bot_space'),
        datas=pulumi.get(__ret__, 'datas'),
        host=pulumi.get(__ret__, 'host'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        name_regex=pulumi.get(__ret__, 'name_regex'),
        output_file=pulumi.get(__ret__, 'output_file'),
        path=pulumi.get(__ret__, 'path'),
        project_name=pulumi.get(__ret__, 'project_name'),
        rule_tag=pulumi.get(__ret__, 'rule_tag'),
        total_count=pulumi.get(__ret__, 'total_count'))


@_utilities.lift_output_func(bot_analyse_protect_rules)
def bot_analyse_protect_rules_output(bot_space: Optional[pulumi.Input[str]] = None,
                                     host: Optional[pulumi.Input[str]] = None,
                                     name: Optional[pulumi.Input[Optional[str]]] = None,
                                     name_regex: Optional[pulumi.Input[Optional[str]]] = None,
                                     output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                     path: Optional[pulumi.Input[Optional[str]]] = None,
                                     project_name: Optional[pulumi.Input[Optional[str]]] = None,
                                     rule_tag: Optional[pulumi.Input[Optional[str]]] = None,
                                     opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[BotAnalyseProtectRulesResult]:
    """
    Use this data source to query detailed information of waf bot analyse protect rules
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo = volcengine.waf.get_bot_analyse_protect_rules(bot_space="BotRepeat",
        host="www.tf-test.com")
    ```


    :param str bot_space: Bot protection rule type.
    :param str host: Website domain names that require the setting of protection rules.
    :param str name: The name of the rule.
    :param str name_regex: A Name Regex of Resource.
    :param str output_file: File name where to save data source results.
    :param str path: Protective path.
    :param str project_name: The name of the project to which your domain names belong.
    :param str rule_tag: Unique identification of rules.
    """
    pulumi.log.warn("""bot_analyse_protect_rules is deprecated: volcengine.waf.BotAnalyseProtectRules has been deprecated in favor of volcengine.waf.getBotAnalyseProtectRules""")
    ...
