# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['SystemBotArgs', 'SystemBot']

@pulumi.input_type
class SystemBotArgs:
    def __init__(__self__, *,
                 bot_type: pulumi.Input[str],
                 host: pulumi.Input[str],
                 action: Optional[pulumi.Input[str]] = None,
                 enable: Optional[pulumi.Input[int]] = None,
                 project_name: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a SystemBot resource.
        :param pulumi.Input[str] bot_type: The name of bot.
        :param pulumi.Input[str] host: Domain name information.
        :param pulumi.Input[str] action: The execution action of the Bot.
        :param pulumi.Input[int] enable: Whether to enable bot.
        :param pulumi.Input[str] project_name: The Name of the affiliated project resource.
        """
        pulumi.set(__self__, "bot_type", bot_type)
        pulumi.set(__self__, "host", host)
        if action is not None:
            pulumi.set(__self__, "action", action)
        if enable is not None:
            pulumi.set(__self__, "enable", enable)
        if project_name is not None:
            pulumi.set(__self__, "project_name", project_name)

    @property
    @pulumi.getter(name="botType")
    def bot_type(self) -> pulumi.Input[str]:
        """
        The name of bot.
        """
        return pulumi.get(self, "bot_type")

    @bot_type.setter
    def bot_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "bot_type", value)

    @property
    @pulumi.getter
    def host(self) -> pulumi.Input[str]:
        """
        Domain name information.
        """
        return pulumi.get(self, "host")

    @host.setter
    def host(self, value: pulumi.Input[str]):
        pulumi.set(self, "host", value)

    @property
    @pulumi.getter
    def action(self) -> Optional[pulumi.Input[str]]:
        """
        The execution action of the Bot.
        """
        return pulumi.get(self, "action")

    @action.setter
    def action(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "action", value)

    @property
    @pulumi.getter
    def enable(self) -> Optional[pulumi.Input[int]]:
        """
        Whether to enable bot.
        """
        return pulumi.get(self, "enable")

    @enable.setter
    def enable(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "enable", value)

    @property
    @pulumi.getter(name="projectName")
    def project_name(self) -> Optional[pulumi.Input[str]]:
        """
        The Name of the affiliated project resource.
        """
        return pulumi.get(self, "project_name")

    @project_name.setter
    def project_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "project_name", value)


@pulumi.input_type
class _SystemBotState:
    def __init__(__self__, *,
                 action: Optional[pulumi.Input[str]] = None,
                 bot_type: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 enable: Optional[pulumi.Input[int]] = None,
                 host: Optional[pulumi.Input[str]] = None,
                 project_name: Optional[pulumi.Input[str]] = None,
                 rule_tag: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering SystemBot resources.
        :param pulumi.Input[str] action: The execution action of the Bot.
        :param pulumi.Input[str] bot_type: The name of bot.
        :param pulumi.Input[str] description: The description of the Bot.
        :param pulumi.Input[int] enable: Whether to enable bot.
        :param pulumi.Input[str] host: Domain name information.
        :param pulumi.Input[str] project_name: The Name of the affiliated project resource.
        :param pulumi.Input[str] rule_tag: The ID of the Bot rule.
        """
        if action is not None:
            pulumi.set(__self__, "action", action)
        if bot_type is not None:
            pulumi.set(__self__, "bot_type", bot_type)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if enable is not None:
            pulumi.set(__self__, "enable", enable)
        if host is not None:
            pulumi.set(__self__, "host", host)
        if project_name is not None:
            pulumi.set(__self__, "project_name", project_name)
        if rule_tag is not None:
            pulumi.set(__self__, "rule_tag", rule_tag)

    @property
    @pulumi.getter
    def action(self) -> Optional[pulumi.Input[str]]:
        """
        The execution action of the Bot.
        """
        return pulumi.get(self, "action")

    @action.setter
    def action(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "action", value)

    @property
    @pulumi.getter(name="botType")
    def bot_type(self) -> Optional[pulumi.Input[str]]:
        """
        The name of bot.
        """
        return pulumi.get(self, "bot_type")

    @bot_type.setter
    def bot_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "bot_type", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        The description of the Bot.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def enable(self) -> Optional[pulumi.Input[int]]:
        """
        Whether to enable bot.
        """
        return pulumi.get(self, "enable")

    @enable.setter
    def enable(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "enable", value)

    @property
    @pulumi.getter
    def host(self) -> Optional[pulumi.Input[str]]:
        """
        Domain name information.
        """
        return pulumi.get(self, "host")

    @host.setter
    def host(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "host", value)

    @property
    @pulumi.getter(name="projectName")
    def project_name(self) -> Optional[pulumi.Input[str]]:
        """
        The Name of the affiliated project resource.
        """
        return pulumi.get(self, "project_name")

    @project_name.setter
    def project_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "project_name", value)

    @property
    @pulumi.getter(name="ruleTag")
    def rule_tag(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the Bot rule.
        """
        return pulumi.get(self, "rule_tag")

    @rule_tag.setter
    def rule_tag(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "rule_tag", value)


class SystemBot(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 action: Optional[pulumi.Input[str]] = None,
                 bot_type: Optional[pulumi.Input[str]] = None,
                 enable: Optional[pulumi.Input[int]] = None,
                 host: Optional[pulumi.Input[str]] = None,
                 project_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to manage waf system bot
        ## Example Usage

        ```python
        import pulumi
        import pulumi_volcengine as volcengine

        foo = volcengine.waf.SystemBot("foo",
            action="observe",
            bot_type="feed_fetcher",
            enable=0,
            host="www.tf-test.com",
            project_name="default")
        ```

        ## Import

        WafSystemBot can be imported using the id, e.g.

        ```sh
        $ pulumi import volcengine:waf/systemBot:SystemBot default BotType:Host
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] action: The execution action of the Bot.
        :param pulumi.Input[str] bot_type: The name of bot.
        :param pulumi.Input[int] enable: Whether to enable bot.
        :param pulumi.Input[str] host: Domain name information.
        :param pulumi.Input[str] project_name: The Name of the affiliated project resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: SystemBotArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to manage waf system bot
        ## Example Usage

        ```python
        import pulumi
        import pulumi_volcengine as volcengine

        foo = volcengine.waf.SystemBot("foo",
            action="observe",
            bot_type="feed_fetcher",
            enable=0,
            host="www.tf-test.com",
            project_name="default")
        ```

        ## Import

        WafSystemBot can be imported using the id, e.g.

        ```sh
        $ pulumi import volcengine:waf/systemBot:SystemBot default BotType:Host
        ```

        :param str resource_name: The name of the resource.
        :param SystemBotArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(SystemBotArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 action: Optional[pulumi.Input[str]] = None,
                 bot_type: Optional[pulumi.Input[str]] = None,
                 enable: Optional[pulumi.Input[int]] = None,
                 host: Optional[pulumi.Input[str]] = None,
                 project_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = SystemBotArgs.__new__(SystemBotArgs)

            __props__.__dict__["action"] = action
            if bot_type is None and not opts.urn:
                raise TypeError("Missing required property 'bot_type'")
            __props__.__dict__["bot_type"] = bot_type
            __props__.__dict__["enable"] = enable
            if host is None and not opts.urn:
                raise TypeError("Missing required property 'host'")
            __props__.__dict__["host"] = host
            __props__.__dict__["project_name"] = project_name
            __props__.__dict__["description"] = None
            __props__.__dict__["rule_tag"] = None
        super(SystemBot, __self__).__init__(
            'volcengine:waf/systemBot:SystemBot',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            action: Optional[pulumi.Input[str]] = None,
            bot_type: Optional[pulumi.Input[str]] = None,
            description: Optional[pulumi.Input[str]] = None,
            enable: Optional[pulumi.Input[int]] = None,
            host: Optional[pulumi.Input[str]] = None,
            project_name: Optional[pulumi.Input[str]] = None,
            rule_tag: Optional[pulumi.Input[str]] = None) -> 'SystemBot':
        """
        Get an existing SystemBot resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] action: The execution action of the Bot.
        :param pulumi.Input[str] bot_type: The name of bot.
        :param pulumi.Input[str] description: The description of the Bot.
        :param pulumi.Input[int] enable: Whether to enable bot.
        :param pulumi.Input[str] host: Domain name information.
        :param pulumi.Input[str] project_name: The Name of the affiliated project resource.
        :param pulumi.Input[str] rule_tag: The ID of the Bot rule.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _SystemBotState.__new__(_SystemBotState)

        __props__.__dict__["action"] = action
        __props__.__dict__["bot_type"] = bot_type
        __props__.__dict__["description"] = description
        __props__.__dict__["enable"] = enable
        __props__.__dict__["host"] = host
        __props__.__dict__["project_name"] = project_name
        __props__.__dict__["rule_tag"] = rule_tag
        return SystemBot(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def action(self) -> pulumi.Output[str]:
        """
        The execution action of the Bot.
        """
        return pulumi.get(self, "action")

    @property
    @pulumi.getter(name="botType")
    def bot_type(self) -> pulumi.Output[str]:
        """
        The name of bot.
        """
        return pulumi.get(self, "bot_type")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[str]:
        """
        The description of the Bot.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def enable(self) -> pulumi.Output[int]:
        """
        Whether to enable bot.
        """
        return pulumi.get(self, "enable")

    @property
    @pulumi.getter
    def host(self) -> pulumi.Output[str]:
        """
        Domain name information.
        """
        return pulumi.get(self, "host")

    @property
    @pulumi.getter(name="projectName")
    def project_name(self) -> pulumi.Output[Optional[str]]:
        """
        The Name of the affiliated project resource.
        """
        return pulumi.get(self, "project_name")

    @property
    @pulumi.getter(name="ruleTag")
    def rule_tag(self) -> pulumi.Output[str]:
        """
        The ID of the Bot rule.
        """
        return pulumi.get(self, "rule_tag")

